// CasovnikTest.java  Ispitivanje klase asovnika.

import java.awt.*;
import java.awt.event.*;
import usluge.*;

public class CasovnikTest extends Frame {

  private asovnik asovnik;                       // Korieni asovnik.

  private void popuniProzor() {                    // Popunjavanje prozora:
    Label datum = new Label("", Label.CENTER),     // - oznake za datum
          vreme = new Label("", Label.CENTER);     //   i vreme,
    vreme.setFont(new Font(null, Font.BOLD, 24));
    add(datum, "North"); add(vreme, "Center");
    try { asovnik = new asovnik(new Polje(datum),     // - stvaranje 
                                  new Polje(vreme)); }  //   asovnika,
      catch (GreKompNeOdgovara g) {}

    Panel ploa = new Panel(); add(ploa, "South");// - ploa za dugmad,

    // - dugme za pokretanje asovnika,
    Button dugme = new Button("Kreni");
    ploa.add(dugme);
    dugme.addActionListener(dog -> { asovnik.kreni(); });

    // - dugme za zaustavljanje asovnika,
    ploa.add(dugme = new Button("Stani"));
    dugme.addActionListener(dog -> { asovnik.stani(); });

    // - dugme za unitavanje asovnika i zatvaranje prozora.
    ploa.add(dugme = new Button("Zavri"));
    dugme.addActionListener(dog -> { asovnik.zavri(); dispose(); });
  }

  private CasovnikTest() {                      // Inicijalizacija:
    super("asovnik");
    setBounds(100, 100, 240, 150);
    popuniProzor();                             // - popunjavanje prozora,
    addWindowListener(new WindowAdapter() {     // - obrada zatvaranja
      @Override                                 //   prozora.
      public void windowClosing(WindowEvent dog)
        { asovnik.zavri(); dispose(); }
    });
  }

  public static void main(String[] varg)        // GLAVNA METODA.
    { new CasovnikTest().setVisible(true); }
}
