// Figure3Test.java - Ispitivanje klasa za crtanje.

import figure3.*;
import java.awt.*;
import java.awt.event.*;

public class Figure3Test extends Frame {

  private Platno platno = new Platno();            // Platno za crtanje.
  private Label taka = new Label("Boja take:");  // Prikaz koordinata.
  private Label boja  = new Label("           ");  // Prikaz boje take.

  private void popuniProzor() {               // Popunjavanje prozora:
    add(platno, "Center");
    platno.addMouseMotionListener(new MouseMotionAdapter(){
      @Override
      public void mouseMoved(MouseEvent dog){ // - obrada pomeranja mia,
        Point p = dog.getPoint();
        taka.setText("Boja take(" + (int)p.getX() + "," +
                                      (int)p.getY() + "): " );
        boja.setBackground(platno.boja(p));
        validate();
      }
    });
    Panel ploa = new Panel();                // - ploa za prikaz podataka.
    add(ploa, "North"); ploa.add(taka); ploa.add(boja);
  }

  private Figure3Test() {                     // Inicijalizacija.
    super("Crtanje figura");
    setBounds(100, 100, 320, 280);
    popuniProzor();
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog) { dispose();  }
    });
  }

  public static void main(String[] varg) {    // Glavna metoda.
    Figure3Test crt = new Figure3Test();
    try {
      crt.platno
        .dodaj(new Crte(Color.GREEN, new Point(80,30), 200, 150)
          .dodaj(new Pravoug(Color.BLACK, new Point(-10,-10),
                             new Point(50,70))               )
          .dodaj(new Crte(Color.GRAY, new Point(100,-20), 90, 50)
            .dodaj(new Krug(Color.BLUE, new Point(40,30), 30))    )
          .dodaj(new Krug(Color.CYAN, new Point(110,90), 50)))
        .dodaj(new Krug(Color.MAGENTA, new Point(70, 100), 50))
        .dodaj(new Krug(Color.RED, new Point(0, 0), 50))
        .dodaj(new Mnogougao(new Color(160, 160, 160))
          .dodaj(new Point( 20,  60))
          .dodaj(new Point(150, 250))
          .dodaj(new Point(200, 100))
          .dodaj(new Point( 20, 200))
          .dodaj(new Point(100,  50))
          .dodaj(new Point(200, 200))                  );
      crt.setVisible(true);
    } catch (GreFigure g) { System.out.println(g); }
  }
}
