// Funkcije1Test.java - Ispitivanje grafikog prikazivanja funkcija.

import funkcije1.*;

public class Funkcije1Test {

  public static void main(String[] varg) {
    
    // Funkcija je zadata objektom "obine" klase.
    Poli poli = new Poli(new double []{4,-4,-1,1});  // (x+2)(x-1)(x-2)
    Grafik.grafik(poli, -3, 3, 61, -3, 7, 11);
    System.out.println();
 
    // Funkcija je zadata objektom lokalne klase.
    class Lok implements Fun {                       // - lokalna klasa
      @Override
      public double f(double x) {
        return (x-2)*(x+2)*(x-1)/(x+1);
      }
    }
    Grafik.grafik(new Lok(), -1.001, 3, 61, -1, 9, 11);
    System.out.println();
    
    // Funkcija je zadata objektom bezimene klase.
    Grafik.grafik(
      new Fun(){                                     // - bezimena klasa
        @Override                                    //   kao argument
        public double f(double x) { return Math.sin(x)/x; }
      },
      0.001, 20, 61, -0.2, 1, 13
    );
    System.out.println();
    
    // Funkcija je zadata lambda izrazom.
    Grafik.grafik(x->Math.exp(-0.1*x)*Math.sin(x),   // - lambda izraz
                  0, 20, 61, -1, 1, 11);
    System.out.println();
    
    // Funkcija je zadata pokazivaem na nestatiku metodu.
    Grafik.grafik(poli::izvod, -3, 3, 61, -7, 7, 11);
    System.out.println();
    
    // Funkcija je zadata pokazivaem na statiku metodu.
    Grafik.grafik(Math::sin, 0, 20, 61, -1, 1, 11);
  }
}
