// LinijeTest.java - Ispitivanje klasa linija u ravni.

import linije.*;

public class LinijeTest {
  private static java.util.Scanner skn = new java.util.Scanner(System.in);
    
  private static Linija itaj() {          // itanje jedne linije.
    System.out.print("Vrsta (D, I, P)? ");
    String vrs = skn.next();
    return switch (vrs.toLowerCase()) {
      case "d" -> {
        System.out.print("A? ");
        double xA = skn.nextDouble(), yA = skn.nextDouble();
        System.out.print("B? ");
        double xB = skn.nextDouble(), yB = skn.nextDouble();
        yield new Du(new Taka(xA, yA), new Taka(xB, yB));
      }
      case "i", "p" -> {
        System.out.print("Broj temena? ");
        Taka[] niz = new Taka [skn.nextInt()];
        for (int i=0; i<niz.length; i++) {
          System.out.print(i+1 + ". teme? ");
          double x = skn.nextDouble(), y = skn.nextDouble();
          niz[i] = new Taka(x, y);
        }
        yield (vrs.equals("i")) ? new Izlomljena(niz)
                                : new Poligon   (niz);
      }
      default -> null;
    };
  }

  public static void main(String[] varg) { // Glavna metoda.
    Linija[] niz = new Linija [Integer.parseInt(varg[0])];
    for (int i=0; i<niz.length; ) {
      Linija lin = itaj();
      if (lin != null) niz[i++] = lin;
        else System.out.println("*** Nepoznata vrsta linije!");
    }
    System.out.println("\nProitano:");
    double max = niz[0].duina(); int imax = 0;
    for (int i=0; i<niz.length; i++) {
      double d = niz[i].duina();
      System.out.println(niz[i] + " d=" + d);
      if (d > max) { max = d; imax = i; }
    }
    System.out.println("\nNajdua: " + niz[imax]);
  }
}
