// Lista3.java - Generika klasa listi.

import java.util.Iterator;
import java.util.NoSuchElementException;

public class Lista3<E> implements Iterable<E> {
  
  private static class Elem<T> {               // Element liste.
    T t;
    Elem<T> sled = null;
    Elem(T tt) { t = tt; };
  }
  
  private Elem<E> prvi = null, posl = null;    // Poetak i kraj liste.

  public void dodaj(E e) {                     // Dodavanje elementa.
    Elem<E> novi = new Elem<E>(e);
    if (prvi == null) prvi = novi; else posl.sled = novi;
    posl = novi;
  }
  
  @Override
  public Iterator<E> iterator()                // Stvaranje iteratora.
    { return new Iter(); }
  
  private class Iter implements Iterator<E> {  // KLASA ITERATORA:
    
    private Elem<E> sled = prvi;               // Sledei element.
    
    @Override
    public boolean hasNext()                   // Ima li sledeeg? 
      { return sled != null; }
    
    @Override
    public E next() throws NoSuchElementException { // Dohvatanje sledeeg.
      if (sled == null) throw new NoSuchElementException();
      E e = sled.t;
      sled = sled.sled;
      return e;
    }

    @Override                                  // Izbacivanje nije podrano.
    public void remove() throws UnsupportedOperationException
      { throw new UnsupportedOperationException(); }
  }
}
