// Lista4.java - Generika klasa ureenih listi.

public class Lista4<E> {
  
  private class Elem<T> {                           // Element liste.
    T t;
    Elem<T> sled;
    Elem(T t, Elem<T> s)
      { this.t = t; sled = s; }
  }
  
  Elem<E> prvi, posl;                               // Poetak i kraj liste.
  Uporeiva<E> upor;                               // Korieni uporeiva.
  
  public Lista4(Uporeiva<E> u) { upor = u; }      // Inicijalizacija.
  
  public Lista4<E> dodaj(E e) {                     // Dodavanje podatka.
    Elem<E> tek = prvi, pret = null;
    while(tek!=null && upor.ispred(tek.t, e))
      { pret = tek; tek = tek.sled; }
    Elem<E> novi = new Elem<>(e, tek);
    if (pret == null) prvi = novi; else pret.sled = novi;
    return this;
  }
  
  @Override
  public String toString() {                        // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (Elem<E> tek=prvi; tek!=null; tek=tek.sled) {
      sb.append(tek.t);
      if (tek.sled != null) sb.append(" ");
    }
    return sb.toString();
  }
}
