// Lista4Test.java - Ispitivanje klase ureenih listi.

public class Lista4Test {
  // Generator jednocifrenih celih brojeva.
  private static int slu() { return (int)(Math.random()*10); }

  // Glavna metoda.
  public static void main(String[] varg) {
    
    // Lokalna klasa parova celih brojeva.
    class Par{
      int a, b;
      Par(int x, int y) { a = x; b = y; }
      @Override public String toString() { return "(" + a + "," + b + ")"; }
    }
    
    // Bezimena klasa uporeivaa parova.
    Uporeiva<Par> upor = new Uporeiva<Par>(){
      @Override public boolean ispred(Par p, Par q) {
        return p.a<q.a || p.a==q.a && p.b<q.b;
      }
    };
    
    // Lista parova (uporeiva je objekat bezimene klase).
    Lista4<Par> lstPar1 = new Lista4<>(upor);
    for (int i=0; i<10; i++) lstPar1.dodaj(new Par(slu(), slu()));
    System.out.println(lstPar1);

    // Lista parova (uporeiva je lambda izraz).
    var lstPar2 = new Lista4<Par>(
      (p,q) -> p.a<q.a || p.a==q.a && p.b<q.b
    );
    for (int i=0; i<10; i++) lstPar2.dodaj(new Par(slu(), slu()));
    System.out.println(lstPar2);
    
    // Lista celih brojeva (uporeiva je lambda izraz).
    Lista4<Integer> lstInt = new Lista4<>((a,b)-> a>b);
    for (int i=0; i<30; i++) lstInt.dodaj(slu());
    System.out.println(lstInt);
  }
}
