// Polica2Test.java - Ispitivanje klase polica za predmete.

import polica2.*;
import predmeti1.*;

public class Polica2Test {
  private static java.util.Scanner skn = new java.util.Scanner(System.in);

  private static class Greka extends Exception { // Klasa za lokalne
    String por;                                   //   greke.
    Greka(String p) { por = p; }
    @Override
    public String toString() { return "*** GREKA: " + por; }
  }

  private static Predmet itaj() throws Greka { // itanje predmeta.
    System.out.print("Vrsta(S-sfera, K-kvadar)? ");
    Predmet p = null;
    switch (skn.next()) {
      case "s", "S" -> p = new Sfera();
      case "k", "K" -> p = new Kvadar();
      default -> throw new Greka("Nepoznata vrsta predmeta!");
    }
    System.out.print("Spec. te. i dimenzije? ");
    p.itaj(skn); return p;
  }
  
  public static void main(String[] varg) {       // Glavna metoda.
    Polica p = new Polica(Integer.parseInt(varg[0]),
                          Double.parseDouble(varg[1]));
 
    radi: while (true) {
      try {
        System.out.print(
          "\n1. Dodavanje na zadato mesto\n"        +
            "2. Dodavanje na prvo slobodno mesto\n" +
            "3. Uzimanje sa zadatog mesta\n"        +
            "4. Stanje police\n"                    +
            "5. Sadraj police\n"                   +
            "6. Pranjenje police\n"                +
            "0. Kraj rada\n\n"                      +
            "Va izbor? "
        );
        switch (skn.next()) {
          case "1" -> { System.out.print("Indeks? ");
                        int i = skn.nextInt();
                        p.stavi(itaj(), i);
                      }
          case "2" -> p.stavi(itaj());
          case "3" -> { System.out.print("Indeks? ");
                        System.out.println(p.uzmi(skn.nextInt()));
                      }
          case "4" -> System.out.println(
                      "Kapacitet= " + p.kapacitet() + 
                      " slobodno= " + p.slobodno() +
                      "\nNosivost= " + p.nosivost() +
                      " teret= " + p.teret());
          case "5" -> System.out.print(p);
          case "6" -> p.prazni();
          case "0" -> { break radi; }
          default  -> throw new Greka("Nedozvoljen izbor!");
        }
      } catch (GrePolica | Greka g) { System.out.println(g); }
    }
  }
}
