// Polinom2.java - Crtanje polinoma.

import java.awt.*;
import java.awt.event.*;

public class Polinom2 extends Frame {
  private double xmin=-10, xmax=10,      // Granine vrednosti koordinata. 
                 ymin=-10, ymax=10;
  private double[] poli;                 // Koeficijenti polinoma.
 
  private TextField                      // Polja za tekst za unos:
    tksXmin = new TextField(""+xmin, 3), // - graninih vrednosti
    tksXmax = new TextField(""+xmax, 3), //   koordinata,
    tksYmin = new TextField(""+ymin, 3),
    tksYmax = new TextField(""+ymax, 3),
    tksPoli = new TextField("1 1 -2 0"); // - koeficijenata polinoma.
  private Button dgmCrtaj = new Button("Crtaj"); // Komandno dugme.
  private Platno platno = new Platno();          // Platno za crtanje.
  
  private double poli(double x) {                // Vrednost polinoma.
    double p = 0;
    for (int i=poli.length; i>0; p=p*x+poli[--i]);
    return p;
  }
  
  private class Platno extends Canvas {  // KLASA PLATNA PO KOME SE CRTA.
    private int ir, vis;                // irina i visina platna.
    
    private int a(double x) {            // Preslikavanje koordinate x.
      return (int)((x-xmin) / (xmax-xmin) * (ir-1));
    }

    private int b(double y) {            // Preslikavanje koordinate y.
      return (int)((ymax-y) / (ymax-ymin) * (vis-1));
    }

    @Override
    public void paint(Graphics g) {            // Crtanje krive:
      ir  = getWidth(); vis  = getHeight();   // - dimenzije platna,
      g.setColor(new Color(240,240,240));      // - popunjavanje podloge,
      g.fillRect(0, 0, ir, vis);
      try {
        xmin = Double.parseDouble(tksXmin.getText()); // - granine
        xmax = Double.parseDouble(tksXmax.getText()); //   vrednosti
        ymin = Double.parseDouble(tksYmin.getText()); //   koordinata,
        ymax = Double.parseDouble(tksYmax.getText());
        String[] s = tksPoli.getText().split(" ");    // - koeficijenti
        int n = s.length - 1;                         //   polinoma,
        poli = new double [n+1];
        for (int i=0; i<=n; i++)
          poli[n-i] = Double.parseDouble(s[i]);
        double dx = (xmax - xmin) / 300;       // - korak du x-ose,
        g.setColor(Color.BLACK);               // - crtanje funkcije,
        int a0 = a(xmin), b0 = b(poli(xmin));
        for (double x=xmin+dx; x<=xmax; x+=dx) {
          double y = poli(x);
          int a = a(x), b = b(y);
          g.drawLine(a0, b0, a, b);
          a0 = a; b0 = b;
        }
      } catch (NumberFormatException gr) {     // - obrada greke.
        g.setColor(Color.RED);
        g.setFont(new Font(null, Font.BOLD, 24));
        g.drawString("Greka", ir/2-40, vis/2+8);
      }
    } // paint()
  } // class Platno
 
  private void popuniProzor() {                // Popunjavanje prozora.
    add(platno, "Center");
    Panel plo = new Panel(new BorderLayout()); add(plo, "North");
    plo.add(new Label("poli:", Label.RIGHT), "West");
    plo.add(tksPoli, "Center");
    plo.add(dgmCrtaj, "East");
    dgmCrtaj.addActionListener(dog -> { platno.repaint(); });
    add(plo = new Panel(), "South");
    plo.add(new Label("x:", Label.RIGHT));
    plo.add(tksXmin); plo.add(tksXmax);
    plo.add(new Label("y:", Label.RIGHT));
    plo.add(tksYmin); plo.add(tksYmax);
  }
  
  public Polinom2() {                          // Inicijalizacija.
    super("Polinom");
    setSize(300, 200);
    popuniProzor();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog) {
        dispose();
      }
    });
  }
  
  public static void main(String[] varg)       // GLAVNA METODA.
    { new Polinom2(); }
}
