// PoljeTest.java - Ispitivanje klase polja grafike korisnike povri.

import usluge.*;
import java.awt.*;
import java.awt.event.*;

public class PoljeTest extends Frame {

  private Label rez;                             // Oznaka vrste rezultata.
  private Kompl2 prvi, drugi, rezult;            // Operandi i rezultat.
  private final String[] oper =                  // Natpisi dugmadi.
    {"Zbir", "Razlika", "Proizvod", "Kolinik"};

  private void popuniProzor() {                  // Popunjavanje prozora:

    Panel plo = new Panel(new GridLayout(3, 1)); // - ploa za oznake
    add(plo, "West");                            //   podataka,
    plo.add(new Label("Prvi"));
    plo.add(new Label("Drugi"));
    plo.add(rez = new Label());   

    add(plo = new Panel(new GridLayout(3, 2)), "Center");  // - ploa za
    try {                                                  //   podatke,
      TextField re = new TextField(), im = new TextField();
      plo.add(re); plo.add(im);
      prvi = new Kompl2(new Polje(re), new Polje(im));
      re = new TextField(); im = new TextField();
      plo.add(re); plo.add(im);
      drugi = new Kompl2(new Polje(re), new Polje(im));
      Label r = new Label(), i = new Label();
      plo.add(r); plo.add(i);
      rezult = new Kompl2(new Polje(r), new Polje(i));
    } catch (GreKompNeOdgovara g) {}

    add(plo = new Panel(), "South");             // - ploa za dugmad.
    DugmeAkcija oslukiva = new DugmeAkcija();
    for (String s: oper) {
      Button dugme = new Button(s);
      plo.add(dugme);
      dugme.addActionListener(oslukiva);
    } 
  } // popuniProzor()
 
  private class DugmeAkcija implements ActionListener {  // Obrada dogaaja
    @Override                                            //   dugmadi.
    public void actionPerformed(ActionEvent dog) {
      String op = ((Button)(dog.getSource())).getLabel();
      try {
        if      (op.equals(oper[0]))
          rezult.postavi(prvi.uzmi().zbir    (drugi.uzmi()));
        else if (op.equals(oper[1]))
          rezult.postavi(prvi.uzmi().razlika (drugi.uzmi()));
        else if (op.equals(oper[2]))
          rezult.postavi(prvi.uzmi().proizvod(drugi.uzmi()));
        else if (op.equals(oper[3]))
          rezult.postavi(prvi.uzmi().kolinik(drugi.uzmi()));
        rez.setText(op); rez.setForeground(Color.BLACK);
      } catch (NumberFormatException g) {
        rez.setText("GREKA"); rez.setForeground(Color.RED);
      }
      validate();
    }
  } // class DugmeAkcija
  
  private PoljeTest() {                         // Inicijalizacija:
    super("Kompleksna aritmetika");
    setBounds(100, 100, 310, 150); setResizable(false);
    popuniProzor();                            // - popunjavanje prozora,
    addWindowListener(new WindowAdapter() {    // - obrada dogaaja prozora.
      @Override
      public void windowClosing(WindowEvent dog) { dispose(); }
    });
  } // PoljeTest()

  public static void main(String[] varg)       // GLAVNA METODA.
    { new PoljeTest().setVisible(true); }  

} // class PoljeTest
