// Rastojanje.java - Rastojanje dve take u grafikom okruenju.

import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Rastojanje extends Frame {
  
  private TextField[] koord = new TextField[6]; // Niz koordinata.
  private Label rez = new Label("0");           // Rezultat.

  private Rastojanje() {                        // Inicijalizacija:
    super("Rastojanje");
    setBounds(100, 100, 250, 150);
    popuniProzor();                             // - popunjavanje prozora,
    setVisible(true);
    addWindowListener(new WindowAdapter() {     // - obrada dogaaja prozora
      @Override
      public void windowClosing(WindowEvent dog) { dispose(); }
    });
  }
 
  private void popuniProzor() {                   // Popunjavanje prozora:
    Panel plo = new Panel(); add(plo, "Center");  // - ploa za koordinate,
    plo.setLayout(new GridLayout(4, 2, 4, 2));
    plo.add(new Label("Prva taka:"));
    plo.add(new Label("Druga taka:"));
    KoordPromena oslukiva = new KoordPromena();
    for (int i=0; i<6; i++) {
      (koord[i] = new TextField("0")).addTextListener(oslukiva);
      plo.add(koord[i]);
    }

    add(plo = new Panel(new GridLayout(4, 1)), "West"); // - ploa za
    String[] ozn = {"", "  X ", "  Y ", "  Z "};        //   oznaavanje
    for (int i=0; i<4; plo.add(new Label(ozn[i++])));   //   vrsta,

    add(plo = new Panel(), "North");              // - ploa za rezultat.
    plo.add(new Label("Rastojanje:"));
    plo.add(rez);
  }

  private class KoordPromena implements TextListener { // Raunanje
    @Override                                          //   rastojanja,
    public void textValueChanged(TextEvent dog) {      //   kad god se
      try {                                            //   promeni neka
        rez.setText(                                   //   koordinata.
          Double.toString(
            Math.sqrt(
              Math.pow(Double.parseDouble(koord[0].getText())-
                       Double.parseDouble(koord[1].getText())  ,2) +
              Math.pow(Double.parseDouble(koord[2].getText())-
                       Double.parseDouble(koord[3].getText())  ,2) +
              Math.pow(Double.parseDouble(koord[4].getText())-
                       Double.parseDouble(koord[5].getText())  ,2)
            )
          )
        );
      } catch (NumberFormatException g) {
        rez.setText("GREKA!");
      }
      validate(); // (da bi se komponente prozora prerasporedile
    }             //  zbog promene broja cifara u rezultatu)
  }

  public static void main(String[] varg)               // Glavna metoda.
    { new Rastojanje(); }
}
