// SamoposlugaTest.java  Ispitivanje rada samoposluge.

import samoposluga.Samoposluga;
import usluge.*;
import java.awt.*;
import java.awt.event.*;

public class SamoposlugaTest extends Frame {

  private Samoposluga samoposl;          // Samoposluga koja se obrauje.
  private Button dgmOtvori  = new Button("Otvori"),    // Upravljaka
                 dgmZatvori = new Button("Zatvori"),   //   dugmad.
                 dgmUniti  = new Button("Uniti");

  private void ploUlazi(int brUlaza, Polje[] pUlazi) { // Ploa za ulaze.
    Panel plo = new Panel(new GridLayout(0, 1)); add(plo, "West");
    plo.setBackground(new Color(192, 255, 192));
    try {
      for (int i=0; i<brUlaza; i++) {
        Label oznaka = new Label();
        plo.add(oznaka);
        pUlazi[i] = new Polje(oznaka);
      }
    } catch (GreKompNeOdgovara g) {}
  }
                                         // Ploa za kase i redove.
  private void ploKaseRedovi(int brKasa, Polje[] pKase, Polje[] pRedovi) {
    Panel plo = new Panel(new BorderLayout()); add(plo, "Center");
    Panel ploKase   = new Panel(new GridLayout(1, brKasa)),
          ploRedovi = new Panel(new GridLayout(1, brKasa));
    plo.add(ploKase, "North"); plo.add(ploRedovi, "Center");
    ploKase  .setBackground(new Color(192, 192, 255));
    ploRedovi.setBackground(new Color(192, 192, 192));

    try {
      for (int i=0; i<brKasa; i++) {
        Label oznaka = new Label();
        ploKase.add(oznaka);
        pKase[i] = new Polje(oznaka);
        TextArea tekst = new TextArea();
        ploRedovi.add(tekst);
        pRedovi[i] = new Polje(tekst);
      }
    } catch (GreKompNeOdgovara g) {}
  }
  
  private void ploKomande(Polje[] pKupci) { // Ploa za upravljaku dugmad.
    Panel plo = new Panel(); add(plo, "North");
    plo.setBackground(new Color(255, 192, 192));
    plo.add(dgmOtvori );
    plo.add(dgmZatvori);
    plo.add(dgmUniti );
    dgmZatvori.setEnabled(false);
    dgmOtvori .addActionListener(akcija);
    dgmZatvori.addActionListener(akcija);
    dgmUniti .addActionListener(akcija);
    Label oznKupci = new Label();
    plo.add(oznKupci);
    try { pKupci[0] = new Polje(oznKupci); }
      catch (GreKompNeOdgovara g) {}
  }

  ActionListener akcija = dog -> {            // Obrada pritisaka na
    Component k = (Component)dog.getSource(); //   upravljaku dugmad.
    if (k == dgmOtvori ) {
      dgmOtvori.setEnabled(false);
      dgmZatvori.setEnabled(true);
      samoposl.otvori();
    }
    if (k == dgmZatvori)
      new Thread(                             // - nit za zatvaranje
        samoposl.niti(),                      //   samoposluge
        () -> {
          dgmOtvori.setEnabled(false);
          dgmZatvori.setEnabled(false);
          samoposl.zatvori(); 
          dgmOtvori.setEnabled(true);
        }
      ).start();
    if (k == dgmUniti ) { samoposl.uniti(); dispose(); }
  };

  private void popuniProzor(String[] vpar) {  // Popunjavanje prozora i
                                              //   stvaranje samoposluge:
    int brUlaza = Integer.parseInt(vpar[1]),
        brKasa  = Integer.parseInt(vpar[2]);
    Polje[] pUlazi = new Polje [brUlaza];     // - ploa za ulaze,
    ploUlazi(brUlaza, pUlazi);
    Polje[] pKase   = new Polje [brKasa];     // - ploa za kase i redove,
    Polje[] pRedovi = new Polje [brKasa];
    ploKaseRedovi(brKasa, pKase, pRedovi);
    Polje[] pKupci = new Polje [1];           // - ploa za komandnu dugmad,
    ploKomande(pKupci);

    samoposl = new Samoposluga(               // - stvaranje samoposluge.
      brUlaza, brKasa,
      Integer.parseInt(vpar[3]),              //   (maxUlaz)
      Integer.parseInt(vpar[4]),              //   (maxKupovina)
      Integer.parseInt(vpar[5]),              //   (maxNaplata)
      pKupci[0], pUlazi, pKase, pRedovi
    );
  }
  private SamoposlugaTest(String[] vpar, int x, int y) { // Inicijalizacija:
    setBounds(x, y, 500, 200);
    popuniProzor(vpar);                       // - popunjavanje prozora,
    setTitle("Samoposluga " + samoposl.id()); // - postavljanje natpisa,
 
    addWindowListener(new WindowAdapter() {   // - obrada zatvaranja
      @Override                               //   prozora.
      public void windowClosing(WindowEvent dog)
        { samoposl.uniti(); dispose(); }
    });
  }

  public static void main(String[] vpar) {    // Glavna metoda.
    for (int i=1; i<=Integer.parseInt(vpar[0]); i++) {
      final int j = i;
      var nit = new Thread(
        new ThreadGroup(""),
        () -> { new SamoposlugaTest(vpar, 50*j, 120*j).setVisible(true); }
      ); 
      nit.start(); 
      try { nit.join(); } catch (InterruptedException e) {}
    }
  }
}
