// Skladiste3Test.java - Ispitivanje klasa proizvoaa i potroaa.

import java.awt.*; import java.awt.event.*;
import usluge.*;   import skladite3.*;

public class Skladiste3Test extends Frame {

  private Thread[] niti;                 // Niti proizvoaa i potroaa.

  public Skladiste3Test(String[] vpar) { // SASTAVLJANJE PROZORA I
    super("Proizvoai/potroai");      //   INICIJALIZACIJA SISTEMA:
    setBounds(100, 100, 300, 200);

    Panel ploa = new Panel(new GridLayout(1, 3)); // Ploa za natpise.
    add(ploa, "North");
    ploa.add(new Label("Proizvoai:"));
    ploa.add(new Label("Skladite:"));
    ploa.add(new Label("Potroai:"));            // Ploa za podatke.

    add(ploa = new Panel(new GridLayout(1, 3)), "Center");
    List lstProizvoai = new List();
    TextArea tksSkladite = new TextArea();
    List lstPotroai = new List();
    lstProizvoai.setMultipleMode(true);
    lstPotroai.setMultipleMode(true);
    ploa.add(lstProizvoai);
    ploa.add(tksSkladite);
    ploa.add(lstPotroai);
    ploa.setEnabled(false);                 // Parametri rada:

    int kap    = Integer.parseInt(vpar[0]),  // - kapacitet skladita,
        brPro  = Integer.parseInt(vpar[1]),  // - broj proizvoaa,
        minPro = Integer.parseInt(vpar[2]),  // - najkrae i najdue vreme
        maxPro = Integer.parseInt(vpar[3]),  //   proizvodnje,
        prPot  = Integer.parseInt(vpar[4]),  // - broj potroaa,
        minPot = Integer.parseInt(vpar[5]),  // - najkrae i najdue vreme
        maxPot = Integer.parseInt(vpar[6]);  //   potronje.
    try {
      Skladite skladite = new Skladite(kap, new Polje(tksSkladite));
      niti = new Thread [brPro + prPot]; int k = 0;
      for (int i=0; i<brPro; i++) {
        lstProizvoai.add("***");
        (niti[k++] = new Proizvoa(skladite, minPro, maxPro,
                          new Polje(lstProizvoai,i))).start();
      }
      for (int i=0; i<prPot; i++) {
        lstPotroai.add("***");
        (niti[k++] = new Potroa(skladite, minPot, maxPot,
                          new Polje(lstPotroai, i))).start();
      }
    } catch (GreKompNeOdgovara g) {}

    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog)
        { for (Thread nit: niti) nit.interrupt(); dispose(); }
    });
  }

  public static void main(String[] vpar)     // GLAVNA METODA.
    { new Skladiste3Test(vpar).setVisible(true); }
}
