// StrujaTest.java  Ispitivanje klasa elektrinih potraa.

import struja.*;
import java.util.Scanner;

public class StrujaTest {
  private static Scanner skn = new Scanner(System.in);

  private static Potroa itaj() {             // itanje jednog potroaa:
    System.out.print("Tip (U,G,.)? ");
    return switch (skn.next()) {
      case "u", "U" -> {                        // - ureaj,
        System.out.print("Vrsta? ");
        String v = skn.next();
        System.out.print("Snaga? ");
        double s = skn.nextDouble();
        yield new Ureaj(v, s);
      }
      case "g", "G" -> {                        // - grupa potroaa,
        Grupa g = new Grupa();
        Potroa p = null;
        while ((p=itaj())!=null) g.dodaj(p);
        yield g;
      }
      default -> null;                          // - "prazan" potroa.
    };
  }

  public static void main(String[] varg) {      // Glavna metoda.
    System.out.print("Snaga izvora? ");
    double s = skn.nextDouble();
    System.out.print("Broj prikljuaka? ");
    int k = skn.nextInt();
    Izvor izv = new Izvor(s, k);
    Potroa p;
    int i;
    do {
      p = itaj();
      System.out.print("Prikljuak? ");
      i = skn.nextInt();
    } while (izv.prikljui(p, i));
    System.out.print(izv);
  }
}
