// Uredi5.java  Ureivanje nizova celih brojeva u grafikom okruenju.

import java.awt.*;
import java.awt.event.*;
import ureivai1.*;
import usluge.Uporediv;

public class Uredi5 extends Frame {

  private static int[] duine =
    {100, 200, 500, 1000, 2000, 5000, 10000};    // Mogue duine niza.
  private static Ureiva[] ureivai = {        // Algoritmi ureivanja.
    new MetodaIzbora(),       new MetodaIzbora2(),
    new MetodaUmetanja(),     new MetodaUmetanja2(),
    new MetodaZameneSuseda(), new MetodaPodele()
  };
  private Uporediv[] niz = new Ceo [100];        // Niz za ureivanje.
  private Ureiva ureiva = ureivai[0];      // Trenutni ureiva.
  private TextArea prikaz = new TextArea();      // Prostor za prikaz niza.

  private void puni() { // Punjenje niza sluajnim brojevima.
    for (int i=0; i<niz.length; i++)
      niz[i] = new Ceo((int)(Math.random()*10));
    prikai();
  }

  private void prikai(){ // Prikaivanje sadraja niza.
    int k = (prikaz.getWidth() - 20) / 10;
    String s = "";
    for (int i=0; i<niz.length; i++)
      s += niz[i] + ((k==0 || i%k==k-1 ||
                      i==niz.length-1) ? "\n" : " ");
    prikaz.setText(s);
  }

  private void popuniProzor() {  // Popunjavanje prozora.
                                 // - prostor za tekst za prikazivanje niza,
    prikaz.addComponentListener(new ComponentAdapter() {
      @Override
      public void componentResized(ComponentEvent dog) { prikai(); }
    });
    puni(); add(prikaz, "Center");
    Panel ploa = new Panel(new GridLayout(0, 1)); add(ploa, "East");
    Choice duina = new Choice();                            // - padajua
    for (int d: duine) duina.addItem(Integer.toString(d)); //   lista za
    duina.addItemListener(new ItemListener() {              //   izbor
      @Override                                              //   duine,
      public void itemStateChanged(ItemEvent dog) {
        int du = Integer.parseInt 
                    (((Choice)dog.getSource()).getSelectedItem());
        niz = new Ceo [du]; puni();
      }
    });
    ploa.add(duina);

    CheckboxGroup grupa = new CheckboxGroup();         // - radio-dugmad za
    RadioPromena oslukiva = new RadioPromena();      //   izbor algoritma.
    for (int i=0; i<ureivai.length; i++) {
      Checkbox radio = new Checkbox(ureivai[i].toString(),
                                    grupa, i==0);
      radio.addItemListener(oslukiva); ploa.add(radio);
    }
  }

  private class RadioPromena implements ItemListener { // Obrada promene
    @Override                                          //   stanja radio-
    public void itemStateChanged(ItemEvent dog) {      //   -dugmeta.
      String naziv = ((Checkbox)dog.getSource()).getLabel();
      int i; for (i=0; i<ureivai.length; i++)
        if (naziv.equals(ureivai[i].toString())) break;
      (ureiva = ureivai[i]).uredi(niz); prikai();
    }
  }

  private void dodajMeni() {                     // Sastavljanje menija.
    MenuBar traka = new MenuBar(); setMenuBar(traka);
    Menu meni = new Menu("Akcija"); traka.add(meni);
    MenuItem stavka = new MenuItem("Pravi", new MenuShortcut('P'));
    stavka.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent dog) { puni(); }
    });
    meni.add(stavka);
    stavka = new MenuItem("Radi", new MenuShortcut('R'));
    stavka.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent dog) 
        { ureiva.uredi(niz); prikai(); }
    });
    meni.add(stavka);
    meni.addSeparator();
    stavka = new MenuItem("Zavri", new MenuShortcut('Z'));
    stavka.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent dog) { dispose(); }
    });
    meni.add(stavka);
  }

  private Uredi5() {                             // Inicijalizacija.
    super("Ureivanje nizova"); setBounds(100, 100, 400, 200);
    popuniProzor(); dodajMeni(); setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog) { dispose(); }
    });
  }

  public static void main(String[] vpar) { new Uredi5(); } // Glavna metoda.
}
