// Ureivai1Test1.java - Ispitivanje klasa za ureivanje nizova.

import ureivai1.*;
import usluge.Uporediv;
import java.util.Random;

public class Uredjivaci1Test1 {
  
  // Niz za objekte algoritama ureivanja.
  private static Ureiva[] metode = {
    new MetodaIzbora(),       new MetodaIzbora2(),
    new MetodaUmetanja(),     new MetodaUmetanja2(),
    new MetodaZameneSuseda(), new MetodaPodele()
  };
  
  // Ispisivanje niza.
  private static void pii(String nasl, Uporediv[] niz) {
    System.out.print("\n" + nasl + "\n\n");
    for (int i=0; i<niz.length; i++) {
      System.out.print(niz[i] + "\t");
      if (i%8==7 || i==niz.length-1) System.out.println();
    }
  }

  // Glavna metoda.
  public static void main(String[] vpar) {
    var skn = new java.util.Scanner(System.in);
    Ureiva metoda = metode[0];
    Uporediv[] niz = new Ceo [1000];
    Random slu = new Random();
    radi: while (true) { // Ispisivanje menija:
      System.out.print(
        "\n1. Zadavanje duine niza\n"                     +
          "2. Postavljanje generatora sluajnih brojeva\n" +
          "3. Izbor algoritma\n"                           +
          "4. Primena algoritma\n"                         +
          "0. Kraj programa\n"                             +
          "Va izbor? "
      );
 
      switch (skn.nextInt()) {

        case 1 -> { // Zadavanje duine niza:
          System.out.print("Duina niza? ");
          int d = skn.nextInt();
          if (d > 0) niz = new Ceo [d];
            else System.out.println("*** Nedozvoljena duina!");
        }

        case 2 -> { // Postavljanje generatora sluajnih brojeva:
          System.out.print("Poetna vrednost generatora? ");
          slu = new Random(skn.nextLong());
        }

        case 3 -> { // Izbor algoritma:
          System.out.println();
          for (int i=0; i<metode.length; i++)
            System.out.println(i+1 + ". " + metode[i]);
          System.out.print("Va izbor? ");
          int izbor = skn.nextInt();
          if (izbor>0 && izbor<=metode.length)
            metoda = metode [izbor-1];
            else System.out.println("*** Nedozvoljen izbor!");
        }

        case 4 -> { // Primena algoritma:
          for (int i=0; i<niz.length; i++)
            niz[i] = new Ceo((int)(slu.nextDouble() * 10000));
          if (niz.length <= 100) pii("Poetni niz:", niz);
          long t1 = System.currentTimeMillis();
          metoda.uredi(niz);
          long t2 = System.currentTimeMillis();
          if (niz.length <= 100) 
            pii("Ureeni niz:", niz);
          else               
            System.out.println(metoda + " (" + niz.length + "): " +
                               (t2-t1)/1000.);
        }

        case 0 -> // Kraj programa:
          { break radi; }

        default -> // Pogrean izbor:
          System.out.println("*** Nedozvoljen izbor!");
      }
    }
  }
}
