// Uredjivaci1Test2.java - Uporeivanje algoritama za ureivanje.

import ureivai1.*;
import java.util.Random;

public class Uredjivaci1Test2 {
  
  // Niz za objekte algoritama ureivanja.
  static Ureiva[] metode = {
    new MetodaIzbora(),       new MetodaIzbora2(),
    new MetodaUmetanja(),     new MetodaUmetanja2(),
    new MetodaZameneSuseda(), new MetodaPodele()
  };
  
  // Ispitivani algoritmi i duine nizova.
  static int[] met = { 0,  1,  2,  3,  4,   3,   5,    5,     5},
               du = {10, 10, 10, 10, 10, 100, 100, 1000, 10000};
  
  static final int PONAV = 10,     // Broj ponavljanja.
                   KLICA = 1;      // Klica generatora sluajnih brojeva.
 
  // Glavna metoda.
  public static void main(String[] vpar) {
    for (int i=0; i<met.length; i++) {
      Ureiva metoda = metode[met[i]];
      int d = du[i] * 1000;
      System.out.printf("%-28s %8d ", metoda, d);
      Ceo[] niz = new Ceo [d];
      Random slu = new Random(KLICA);
      long tsr = 0;
      for (int p=0; p<PONAV; p++) {
        for (int j=0; j<niz.length; j++)
          niz[j] = new Ceo((int)(slu.nextDouble() * 10000));
        long t1 = System.currentTimeMillis();
        metoda.uredi(niz);
        long t2 = System.currentTimeMillis();
        tsr += t2 - t1;
      }
      System.out.printf("%6.3f\n", tsr/1000./PONAV);
    }
  }
}
