// Vektor2.java - Klasa vektora s konkurentnom obradom.

import usluge.Greka;

public class Vektor2 {
  
  private static class Sabirac extends Thread { // KLASA NITI ZA SABIRANJE:
    private double a, b, c;                     // Operandi i rezultat.
    public Sabirac(double p, double q) { a = p; b = q; } // Inicijalizacija.
    @Override
    public void run() { c = a + b; }            // Sadraj niti.
    public double rezultat() { return c; }      // Dohvatanje rezultata.
  }

  private static class Mnoac extends Thread {  // KLASA NITI ZA MNOENJE:
    private double a, b, c;                     // Operandi i rezultat.
    public Mnoac(double p, double q) { a = p; b = q; } // Inicijalizacija.
    @Override
    public void run() { c = a * b; }            // Sadraj niti.
    public double rezultat() { return c; }      // Dohvatanje rezultata.
  }
  
  private double[] niz;                         // Komponente vektora.
  
  public Vektor2(int du) { niz = new double [du]; } // Inicijalizacija.
                                                // Postavljanje komponente.
  public Vektor2 postavi(int ind, double broj) throws Greka {
    if (ind < 0 || ind >= niz.length)
      throw new Greka("Nedozvoljen indeks!");
    niz[ind] = broj;
    return this;
  }

  public double uzmi(int ind) throws Greka {   // Dohvatanje komponente.
    if (ind < 0 || ind >= niz.length)
      throw new Greka("Nedozvoljen indeks!");
    return niz[ind];
  }
 
  @Override
  public String toString() {                    // Tekstualni opis.
    String s = "(";
    for (int i=0; i<niz.length; i++)
      { if (i > 0) s += ","; s += niz[i]; }
    return s + ")";
  }
                                                // Zbir dva vektora:
  public static Vektor2 zbir(Vektor2 v1, Vektor2 v2) throws Greka {
    int n = v1.niz.length, n2 = v2.niz.length;
    if (n != n2) throw new Greka("Neusaglaene duine vektora!");
    Sabirac[] sab = new Sabirac [n];            // - pokretanje niti,
    for (int i=0; i<n; i++)
      (sab[i] = new Sabirac(v1.niz[i], v2.niz[i])).start();
    Vektor2 v = new Vektor2(n);                 // - sakupljanje rezultata.
    for (int i=0; i<n; i++)
      try { sab[i].join(); v.niz[i] = sab[i].rezultat(); }
        catch (InterruptedException g) {}
    return v;
  }
                                                // Skalarni proizvod:
  public static double skalPro(Vektor2 v1, Vektor2 v2) throws Greka {
    int n = v1.niz.length, n2 = v2.niz.length;
    if (n != n2) throw new Greka("Neusaglaene duine vektora!");
    Mnoac[] mno = new Mnoac [n];              // - pokretanje niti,
    for (int i=0; i<n; i++)
      (mno[i] = new Mnoac(v1.niz[i], v2.niz[i])).start();
    double s = 0;                               // - sakupljanje rezultata.
    for (int i=0; i<n; i++)
      try { mno[i].join(); s += mno[i].rezultat(); }
        catch (InterruptedException g) {}
    return s;
  }

  public static void main(String[] vpar) {      // GLAVNA METODA.
    var skn = new java.util.Scanner(System.in);
    while (true) {
      try {
        System.out.print("n1? "); int n1 = skn.nextInt();
    if (n1 < 0) break;
        System.out.print("v1? "); Vektor2 v1 = new Vektor2(n1);
        for (int i=0; i<n1; v1.postavi(i++, skn.nextDouble()));
        System.out.print("n2? "); int n2 = skn.nextInt();
    if (n2 < 0) break;
        System.out.print("v2? ");
        Vektor2 v2 = new Vektor2(n2);
        for (int i=0; i<n2;
          v2.postavi(i++,
                     skn.nextDouble()));
        System.out.println("Zbir: "
          + Vektor2.zbir(v1,v2));
        System.out.println("Skalpro: "
          + Vektor2.skalPro(v1,v2)
          + "\n");
      } catch (Greka g) {
        System.out.println(g + "\n");
      }
    }
  }
}
