// Xox.java - Organizovanje igre XoX.

import xox.*;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Xox extends Frame {

  private Font font = new Font(null, Font.BOLD, 24); // Font za natpise.
  
  private class PloIgra extends Panel { // PLOA ZA IZBOR IGRAA:
                                      // Radio dugmad za izbor vrste igraa.
    private CheckboxGroup grupa = new CheckboxGroup();
    private Checkbox rdgovek   = new Checkbox("ovek"  , true , grupa),
                     rdgRaunar = new Checkbox("Raunar", false, grupa);
    private String oznaka;                          // Oznaka igraa.
    private Igra igra;                            // Pridrueni igra.
    
    PloIgra(String ozn) {                          // Inicijalizacija:
      oznaka = ozn;                                 // - oznaka igraa,
      Label ntp = new Label(ozn, Label.CENTER);
      ntp.setFont(font);
      ItemListener oslukiva = dog -> {            // - oslukiva za izbor
        if ((Checkbox)dog.getSource() == rdgovek)  //   vrste igraa,
          igra = new ovek  (oznaka, tabla);
        else
          igra = new Raunar(oznaka, tabla);
      };
      rdgovek  .addItemListener(oslukiva);
      rdgRaunar.addItemListener(oslukiva);
      setLayout(new GridLayout(3, 1));              // - popunjavanje ploe,
      add(ntp); add(rdgovek); add(rdgRaunar);
      igra = new ovek(oznaka, tabla);             // - poetni igra.
    }
  } // class PloIgra
 
  private Panel ploTabla = new Panel();               // Ploa za polja.
  private Tabla tabla = new Tabla(ploTabla);          // Tabla za igru.
  private PloIgra ploPrvi  = new PloIgra("X");      // Ploe za izbor
  private PloIgra ploDrugi = new PloIgra("O");      //   vrste igraa.
  private Igra igra;                                  // Igra koja se igra.
  private Label stanje = new Label("", Label.CENTER); // Natpis stanja igre.

  public void popuniProzor() {                    // Popunjavanje prozora:
    add(ploTabla, "Center");                      // - ploa za tablu,
    add(ploPrvi , "West"  );                      // - ploe za izbor
    add(ploDrugi, "East"  );                      //   vrste igraa,
    
    Button dugme = new Button("Nova igra");       // - dugme za poetak
    dugme.addActionListener( dog -> {             //   nove igre,
      if (igra != null) igra.prekini();
      igra = new Igra(tabla, ploPrvi.igra, ploDrugi.igra, stanje);
    });
    add(dugme, "South");
    stanje.setFont(font);                         // - natpis stanja igre.
    add(stanje, "North");
  }

  public Xox() {                                  // Inicijalizacija:
    super("XoX");
    setBounds(100, 100, 300, 200);
    popuniProzor();                               // - popunjavanje prozora,
    setVisible(true);

    addWindowListener(new WindowAdapter() {       // - obrada zatvaranja
      @Override                                   //   prozora.
      public void windowClosing(WindowEvent dog)
        { if(igra != null) igra.prekini(); dispose(); }
    });
  } // konstruktor

  public static void main(String[] varg)          // GLAVNA METODA.
    { new Xox(); }
}
