// ZbirkeTest.java - Ispitivanje klasa zbirki.

import zbirke.*;

public class ZbirkeTest {
  
  public static void main(String[] varg) {
    Zbirka[] nizZb = { new NNiz(),   new UNiz(),
                       new NLista(), new ULista() };
    String[] nasl  = { "NEUREEN NIZ", "UREEN NIZ",
                       "NEUREENA LISTA", "UREENA LISTA" };
    int[] niz = {6, 3, 7, 9, 2, 0, 4, 1, 8, 5, 2, 5, 3, 8, 0};
    for (int i=0; i<nizZb.length; i++)
      radi(nasl[i], nizZb[i], niz);
  }
  
  private static void radi(String nasl, Zbirka zb, int[] niz) {
    System.out.println("\n" + nasl);
    try {
      for (int i=0; i<niz.length; zb.dodaj(niz[i++]));
      System.out.println("Napravljena zbirka: " + zb);
      
      System.out.print  ("Indeksiranjem:       ");
      for (int i=0; i<zb.vel(); i++)
        System.out.print(zb.dohvati(i) + " ");
      System.out.println();
      
      System.out.print  ("Iteratorom:          ");
      Iterator it = zb.iterator();
      for (it=it.naPoetak(); it.imaTek(); it.naSledei())
        System.out.print(it.dohvatiTek() + " ");
      System.out.println();
      
      System.out.println("zb[4]=7 (indeksom): " + zb.postavi(4,7));
      
      it.naPoetak();
      for (int i=0; i<7; i++) it.naSledei();
      it.postaviTek(3);
      System.out.println("zb[7]=3  (iterom):  " + zb);
      System.out.println("  tekui:            " + it.dohvatiTek());
      it.briiTek();
      System.out.println("Brii tekui:       " + zb);
      System.out.println("  tekui:            " + it.dohvatiTek());
      System.out.println("Brii zb[10]:       " + zb.brii(10));
    } catch (GreZbirka  g) { System.out.println(g); }
  }
}
