// CeoBroj.java - Klasa celih brojeva.

package aritmetika;

public class CeoBroj implements Numeriko {
  private int i;                                       // Vrednost broja.

  public CeoBroj(int ii) { i = ii; }                   // Inicijalizacija.

  @Override
  public CeoBroj clone() {                             // Kopija broja.
    try { return (CeoBroj)super.clone(); }
      catch (CloneNotSupportedException g) { return null; }
  }

  @Override
  public CeoBroj dodaj(Numeriko b) throws GreNumTip { // Dodavanje broja.
    if (!(b instanceof CeoBroj)) throw new GreNumTip();
    i += ((CeoBroj)b).i;
    return this;
  }

  @Override                                            // Proizvod dva broja
  public CeoBroj proizvod(Numeriko b) throws GreNumTip {
    if (!(b instanceof CeoBroj)) throw new GreNumTip();
    return new CeoBroj(i * ((CeoBroj)b).i);
  }

  @Override
  public String toString()                             // Tekstualni opis.
    { return Integer.toString(i); }
}
