// Niz.java - Generika klasa nizova.

package figure2;

public class Niz<E> {
  E[] niz;                                           // Elementi niza. 
  int n = 0;                                         // Duina niza.
  
  @SuppressWarnings ("unchecked")
  public Niz(int kap)                                // Inicijalizacija.
    { niz = (E[]) new Object[kap]; }
  public Niz() { this(10); }
  
  public int du() { return n; }                     // Duina niza.
  
  public Niz<E> dodaj(E e) throws GrePun {           // Dodavanje elementa.
    if (n == niz.length) throw new GrePun();
    niz[n++] = e;
    return this;
  }
  
  public E dohv(int i) throws GreIndeks {            // Dohvatanje elementa.
    if (i<0 || i>=n) throw new GreIndeks();
    return niz[i];
  }
 
  @Override
  public String toString() {                         // Tekstualni opis.
    StringBuilder sb = new StringBuilder("[");
    for (int i=0; i<n; i++) {
      if (i < 0) sb.append(',');
      sb.append(niz[i]);
    }
    return sb.append(']').toString();
  }
}
