// Crte.java - Klasa crtea.

package figure3;
import  java.awt.*;
import java.util.ArrayList;

public class Crte extends Figura {
  
  private ArrayList<Figura> figure       // Figura u crteu.
    = new ArrayList<>();
  
  private int x, y;                      // Donje levo teme crtea.
  private int ir, vis;                  // irina i visina crtea.
  
  public Crte(Color b, Point T, int s, int v)  // Inicijalizacija.
    { super(b); x = (int)T.getX(); y = (int)T.getY(); ir = s; vis = v; }
    
  public Crte promeniDim(int s, int v)  // Promena dimenzija crtea.
    { ir = s; vis = v; return this; }

  public Crte dodaj(Figura f)           // Dodavanje figure.
    { figure.add(f); return this; }
  
  @Override
  public boolean pripada(Point T) {      // Da li taka pripada?
    int dx = (int)T.getX() - x, dy = (int)T.getY() - y;
    return dx >= 0 && dx <= ir && dy >=0 && dy <= vis;
  }
 
  @Override                              // Boja take.
  public Color boja(Point T)
    throws GreNePripada {
    if (!pripada(T))
      throw new GreNePripada();
    Point T2 = new Point(T);
    T2.translate(-x, -y);
    for (int i=figure.size()-1; i>=0; i--)
      try {
        return figure.get(i).boja(T2);
     } catch (GreNePripada g) {}
    return boja(); 
  }

  @Override
  public void crtaj(Graphics g, int x0, int y0) {  // Crtanje crtea.
    Rectangle staro = g.getClipBounds();
    g.clipRect(x0+x, y0-y-vis, ir, vis);
    g.setColor(boja());
    g.fillRect(x0+x, y0-y-vis, ir, vis);
    for (var fig : figure) fig.crtaj(g, x0+x, y0-y);
    g.setClip(staro);
  }
}
