// ZbirFun.java - Klasa zbirova funkcija.

package izvodi;

public class ZbirFun implements Fun {
  
  private Fun[] niz;                              // Niz funkcija.
  private int du;                                // Broj popunjenih mesta.
  
  public ZbirFun(int n) { niz = new Fun [n]; }       // Inicijalizacija.

  public ZbirFun() { this(2); }

  public ZbirFun dodaj(Fun f) throws GreZbirFunPun { // Dodavanje funkcije.
    if (du == niz.length) throw new GreZbirFunPun();
    niz[du++] = f;
    return this;
  }

  @Override
  public double f(double x) {                        // Raunanje vrednosti.
    double s = 0;
    for (int i=0; i<du; s+=niz[i++].f(x));
    return s;
  }

  @Override
  public Fun izv() {                                 // Stvaranje izvoda.
    ZbirFun z = new ZbirFun(niz.length);
    try {
      for (int i=0; i<du; z.dodaj(niz[i++].izv()));
    } catch (GreZbirFunPun g) {}
    return z;
  }

  @Override
  public String toString() {                         // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<du; i++) {
      if (i > 0) sb.append('+');
      sb.append('(').append(niz[i]).append(')');
    }
    return sb.toString();
  }
}
