// Mesec.java - Nabrajanje meseca u godini.

package kalendar;

public enum Mesec {
  JAN ("jan", "januar"   , 31),
  FEB ("feb", "februar"  , 28)
      { 
         @Override public int brDana(boolean prestupna)
           { return FEB.brDana + (prestupna ? 1 : 0); }
      },
  MAR ("mar", "mart"     , 31),
  APR ("apr", "april"    , 30),
  MAJ ("maj", "maj"      , 31),
  JUN ("jun", "jun"      , 30),
  JUL ("jul", "jul"      , 31),
  AVG ("avg", "avgust"   , 31),
  SEP ("sep", "septembar", 30),
  OKT ("okt", "oktobar"  , 31),
  NOV ("nov", "novembar" , 30),
  DEC ("dec", "decembar" , 31);

  private String oznaka, naziv;                 // Oznaka i naziv meseca.
  private int brDana;                           // Broj dana u mesecu.
  
  Mesec(String ozn, String naz, int brD)        // Inicijalizacija.
    { oznaka = ozn; naziv = naz; brDana = brD; }

  public String oznaka() { return oznaka; }     // Oznaka meseca.
  public String naziv()  { return naziv;  }     // Naziv meseca.
  public int    brDana(boolean prestupna)       // Broj dana u mesecu.
    { return brDana; }
}
