// Lista.java - Klasa listi objekata.

package lista2;

public class Lista {

  private Elem prvi, posl;           // Poetak i kraj liste.
  
  private class Elem {               // Element liste objekata:
    
    Object obj;                      // - sadrani objekat,
    Elem pret, sled;                 // - prethodni i sledei element,
 
    Elem(Object obj) {               // - inicijalizacija elementa,
      this.obj = obj;
      sled = null; pret = posl;
      if (prvi == null) prvi = this; else posl.sled = this;
      posl = this;
    }
    
    void izbaci() {                  // - izbacivanje elementa.
      if (pret != null) pret.sled = sled;
        else prvi = sled;
      if (sled != null) sled.pret = pret;
        else posl = pret;
    }
  } // class Elem

  public Lista dodaj(Object obj)     // Dodavanje objekta na kraj liste.
    { new Elem(obj); return this; }
                                     // Izbacivanje objekta iz liste.
  public Lista izbaci(Object obj) throws GreLstNemaObj {
    Elem tek = prvi; while (tek!=null && tek.obj!=obj) tek=tek.sled;
    if (tek == null) throw new GreLstNemaObj(obj);
    tek.izbaci();
    return this;
  }
  
  private Elem tek;                  // Tekui element liste.
    
  public Lista naPrvi()              // Pomeranje na prvi element.
    { tek = prvi; return this;}
    
  public boolean imaTek() { return tek != null; }   // Ima li tekueg?
  
  public Lista naSledei() {         // Pomeranje na sledei element.
    if (imaTek()) tek = tek.sled;
    return this;
  }
  
  public Object dohvatiTek() throws GreLstNemaTek { // Dohvatanje tekueg
    if (!imaTek()) throw new GreLstNemaTek();       //   objekta.
    return tek.obj;
  }

  public Object izvadiTek() throws GreLstNemaTek {  // Vaenje tekueg
    if (!imaTek()) throw new GreLstNemaTek();       //   objekta.
    Object obj = tek.obj; tek.izbaci(); tek = tek.sled;
    return obj;
  }
  
  public Lista  isprazni()                          // Pranjenje liste.
    { prvi = posl = tek = null; return this; }

  @Override
  public String toString() {                        // Tekstualni opis.
    StringBuilder sb = new StringBuilder("<");
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      if (tek != prvi) sb.append(" # ");
      sb.append(tek.obj);
    }
    return sb.append('>').toString();
  }
}
