// Izvlacenje.java - Klasa izvlaenja.

package lutrija2;
import java.awt.*;
import java.awt.event.*;

public class Izvlacenje extends Frame {
  private static final int DU = 6;         // Broj tokova.
  Maina maina = new Maina(DU);          // Koriena maina.
  Button dgmKreni, dgmStani;                // Komandna dugmad.
  CheckboxGroup grupa = new CheckboxGroup();// Grupa radio dugmadi.
  TextArea tksBrojevi;                      // Prikaz izvuenih brojeva.

  private void moeKreni(boolean da) {      // Upotrebljivost dugmadi.
    dgmKreni.setEnabled( da);
    dgmStani.setEnabled(!da);
  }

  private Panel ploKomande() {              // Ploa komandne dugmadi.
    Panel plo = new Panel();
    plo.add (dgmKreni = new Button("Kreni"));
    dgmKreni.addActionListener(dog -> {
      moeKreni(false);
      maina.kreni(Integer.parseInt(
        grupa.getSelectedCheckbox().getLabel()
      ));
    });
    plo.add (dgmStani = new Button("Stani"));
    dgmStani.addActionListener(dog -> {
      moeKreni(true);
      tksBrojevi.append(maina.stani() + "\n");
    });
    moeKreni(true);
    return plo;
  }

  private Panel ploRadio() {                // Ploa radio-dugmadi.
    Panel plo = new Panel();
    for (int i=DU; i>0; i--)
      plo.add(new Checkbox(i+"", grupa, i==DU));
    return plo;
  }
 
  private Panel ploBrojevi() {              // Ploa izvuenih brojeva.
    Panel plo = new Panel(new BorderLayout());
    plo.add(tksBrojevi = new TextArea(1, 7), "Center");
    Button dgm = new Button("Isprazni");
    plo.add(dgm, "South");
    dgm.addActionListener(dog -> { tksBrojevi.setText(""); });
    return plo;
  }

  private void popuniProzor() {             // Popunjavanje prozora.
    add(ploBrojevi(), "East");
    Panel ploa = new Panel(new BorderLayout());
    add(ploa, "Center");
    ploa.add(maina, "North");
    Panel plo = new Panel(new GridLayout(2,1));
    ploa.add(plo, "South");
    plo.add(ploRadio());
    plo.add(ploKomande());
  }

  public Izvlacenje() {                     // Inicijalizacija.
    super("Izvlaenje");
    setSize(300, 180);
    setResizable(false);
    popuniProzor();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog)
        { maina.uniti(); dispose(); }
    });
  }

  public static void main(String[] varg)    // Glavna metoda.
    { new Izvlacenje(); }
}
