// SloenOtpornik.java - Apstraktna klasa sloenih otpornika.

package otpornici;

public abstract class SloenOtpornik extends ApstraktanOtpornik {
  
  protected Elem prvi, posl; // Poetak i kraj liste sadranih otpornika.
  
  protected class Elem {                // Element liste (unutranja klasa):
    ApstraktanOtpornik R;               // - sadrani otpornik,
    Elem sled;                          // - sledei element liste,
    Elem(ApstraktanOtpornik r) {        // - inicijalizacija.
      R = r; 
      if (prvi == null) prvi = this;
        else            posl.sled = this;
      posl = this;
    }
  }
                                  // Dodavanje otpornika.
  public SloenOtpornik dodaj(ApstraktanOtpornik r)
    { new Elem(r); return this; }
                                  // Simboli za tekstualni opis:
  protected abstract char otv (); // - otvorena zagrada,
  protected abstract char oper(); // - operator,
  protected abstract char zatv(); // - zatvorena zagrada.
  
  @Override
  public final String toString() {      // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    sb.append(otv());
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      sb.append(tek.R);
      if (tek.sled != null) sb.append(oper());
    }
    return sb.append(zatv()).toString ();
  }
}
