// Automobil.java - Klasa automobila.

package parkiranje;

public class Automobil extends Thread {
  private static int posId = 0;                 // Poslednji identifikator.
  private final int id = ++posId;               // Identifikator automobila.
  private String marka;                         // Marka automobila.
  private Parking park;                         // Korieni parking.
  private int t;                                // Trajanje parkiranja.
  
  public Automobil(String m, Parking p, int tmin, int tmax) {
    marka = m; park = p;                        // Inicijalizija.
    t = (int)(tmin + Math.random()*(tmax+tmin)); 
    start();
  }
  
  @Override
  public void run() {                                   // Telo niti.
    try {
      park.ulazi(this); sleep(t); park.izlazi(this);
    } catch (InterruptedException g) {}
  }

  @Override
  public String toString() { return id + "/" + marka; } // Tekstualni opis.
}
