// GraPark.java - Klasa parkinga s grafikim interfejsom.

package parkiranje;
import java.awt.*;

public class GraPark extends Parking {
  private Panel ploa;                  // Prikaziva parkinga.
  private Button[] dugmad;              // Prikazivai mesta za parkiranje.
  
  public GraPark(int kap, int minU, int maxU, int minP, int maxP, int kol) {
    super(kap, minU, maxU, minP, maxP);         // Inicijalizacija.
    ploa = new Panel(new GridLayout(0,kol));
    ploa.setEnabled(false);
    dugmad = new Button [kap];
    for (int i=0; i<kap;
       ploa.add(dugmad[i++] = new Button()));
  }
  
  public Panel ploa() { return ploa; }        // Dohvatanje prikazivaa.

  @Override
  public synchronized void ulazi(Automobil a) throws InterruptedException
    { super.ulazi(a); prikai(); }              // Ulazak automobila.

  @Override
  public synchronized void izlazi(Automobil a)  // Izlazak automobila. 
    { super.izlazi(a); prikai(); }

  private void prikai() {                      // Prikazivanje parkinga.
    try {
      for (int i=0; i<dugmad.length; i++) {
        Automobil a = automobil(i);
        dugmad[i].setLabel(a==null ? "" : a.toString());
      }
    } catch (GreIndeks g) {};
  }
}
