// Parkiranje.java  Organizovanje rada parkinga.

package parkiranje;

import java.awt.*;
import java.awt.event.*;

public class Parkiranje extends Frame {

  private GraPark park =                        // Korieni parking.
    new GraPark(10, 200, 500, 1000, 3000, 3);
  Button dgmOtvori  = new Button("Otvori"),     // Upravljaka dugmad.
         dgmZatvori = new Button("Zatvori"),
         dgmUniti  = new Button("Uniti");
  TextArea tksMarke =                           // Prostor za unos modela.
    new TextArea("BMW\nVW\nOPEL", 1, 6);
  
  private void popuniProzor() {                 // Popunjavanje prozora.
    add(park.ploa(), "Center");
    add(tksMarke, "West");
    Panel plo = new Panel(); add(plo, "South");
    plo.add(dgmOtvori);
    dgmOtvori.addActionListener(dog -> {
      dgmOtvori.setEnabled(false);
      dgmZatvori.setEnabled(true);
      park.ulaz().postavi(tksMarke.getText().split("\n"));
      park.otvori(); 
    });
    plo.add(dgmZatvori).setEnabled(false);
    dgmZatvori.addActionListener(dog -> { 
      dgmOtvori.setEnabled(true);
      dgmZatvori.setEnabled(false);
      park.zatvori();
    });
    plo.add(dgmUniti);
    dgmUniti.addActionListener(dog -> {
      park.uniti(); dispose();
    });
  }

  private Parkiranje() {                        // Inicijalizacija.
    super("Parking"); setSize(270, 150);
    popuniProzor();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog)
       { park.uniti(); dispose(); }
    });
  }
  
  public static void main(String[] varg)        // Glavna metoda.
    { new Parkiranje(); }
}
