// Planinarenje.java  Program za organizovanje planinarenja.

package planinarenje;
import java.awt.*;
import java.awt.event.*;

public class Planinarenje extends Frame {
  private static final int brVod = 5, tDol = 500,   // Parametri rada.
                         maxPlan = 5, tTura = 3000;
  private Drutvo dru = new Drutvo(brVod, tDol);   // Planinarsko drutvo.
  private ThreadGroup niti;                         // Niti u prozoru.
  
  private void popuniProzor() {                     // Popunjavanje prozora:
    Panel plo = new Panel(new GridLayout(1,2));
    add(plo, "Center");
    plo.add(dru.dohvPrik());
    Panel p = new Panel(new GridLayout(0, 1));
    plo.add(p);
    try {
      for (int i=0; i<brVod; i++) {
        Vodi v = new Vodi(dru, maxPlan, tTura);
        dru.dodaj(v); p.add(v.dohvPrik());
      }
    } catch (GrePuno g) {};
    add(plo = new Panel(), "South");
    plo.setBackground(Color.LIGHT_GRAY);
    Button dgm = new Button("Otvori"); plo.add(dgm);
    dgm.addActionListener(dog -> { dru.otvori(); });
    plo.add(dgm = new Button("Zatvori"));
    dgm.addActionListener(dog -> { dru.zatvori(); });    
  }
  
  private Planinarenje () {                         // Inicijalizacija.
    super("Planinarenje"); setSize(240, 180);
    popuniProzor(); setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog)
        { niti.interrupt(); dispose(); }
    });
    niti = Thread.currentThread().getThreadGroup();
  }
  
  public static void main(String[] varg)            // Glavna metoda.
    { new Planinarenje(); }
}
