// Taka.java - Klasa pokretnih taaka.

package pokretni;

public class Taka implements Pokretan {

  private static int posId = 0;     // Poslednji identifikator.
  private final int id = ++posId;   // Identifikator take.
  private Vektor r;                 // Vektor poloaja.
  private Brzina v;                 // Vektor brzine.

  public Taka(Vektor rr, Brzina vv) { r = rr; v = vv; } // Inicijali-
  public Taka() { r = new Vektor(); v = new Brzina(); } //   zacija.

  @Override
  public Taka proteklo(double dt)               // Promena poloaja zbog
    { r = r.zbir(v.proizvod(dt)); return this; } //   proteklog vremena.
  
  public Vektor r() { return r; }                // Trenutni poloaj.
  
  public double rastojanje(Taka T2) // Rastojanje od druge take.
    { return T2.r.zbir(r.proizvod(-1)).intenzitet(); }

  @Override
  public String toString()           // Tekstualni opis.
    { return "T" + id + r; }
}
