// polica.java - Klasa polica za knjige.

package polica1;

public class Polica {
  private Knjiga[] knjige;                       // Niz knjiga.
  private int brKnjiga = 0;                      // Trenutni broj knjiga.
  
  public Polica(int brMesta)                     // Inicijalizacija.
    { knjige = new Knjiga[brMesta]; }
  
  public Polica() { this(10); }
 
  public boolean stavi(Knjiga k) {               // Stavljanje knjige.
    if (brKnjiga == knjige.length) return false;
    int i = 0; while (knjige[i] != null) i++;
    knjige[i] = k;
    return true;
  }
  
  public Knjiga uzmi(int poz) {                  // Uzimanje kjige.
    if (poz<0 || poz>=knjige.length || knjige[poz]==null) return null;
    Knjiga k = knjige[poz];
    knjige[poz] = null;
    brKnjiga--;
    return k;
  }
  
  public double ukVrednost() {                   // Ukupna vrednost knjiga.
    double uv = 0;
    for (var k : knjige)
      if (k != null) uv += k.vrednost();
    return uv;
  }
  
  @Override
  public String toString() {                     // Tekstualni opis;
    String s = "";
    for (var k : knjige)
      if (k != null) s += k + "\n";
    s += "=================================\n";
    s += "Ukupna vrednost: " + ukVrednost() + "\n";
   return s;
  }
}
