// Polica.java - Klasa polica za predmete.

package polica2;
import  predmeti1.Predmet;

public class Polica {
  
  private Predmet[] niz;                 // Niz za smetanje predmeta.
  private double maxQ;                   // Nosivost police.
  private double q = 0;                  // Trenutna optereenost police.
  
  public Polica(int kap, double Qmax) { // Inicijalizacija.
    niz = new Predmet [kap];
    maxQ = Qmax;
  } 
  
  public Polica stavi(Predmet p, int i) // Stavljanje na dato mesto.
    throws GrePolIndeks, GrePolZauzeto, GrePolTeina {
    if (i<0 || i>=niz.length) throw new GrePolIndeks(i);
    if (niz[i] != null)       throw new GrePolZauzeto(i);
    if (q + p.Q() > maxQ)     throw new GrePolTeina(p);
    niz[i] = p; q += p.Q();
    return this;
  }

  public Polica stavi(Predmet p)     // Stavljanje na prvo slobodno mesto.
    throws GrePolTeina, GrePolPuna {
    if (q + p.Q() > maxQ)     throw new GrePolTeina(p);
    int i = 0; while (i<niz.length && niz[i]!=null) i++;
    if (i == niz.length)      throw new GrePolPuna();
    niz[i] = p; q += p.Q();
    return this;
  }

  public Predmet uzmi(int i)         // Uzimanje sa datog mesta.
    throws GrePolIndeks, GrePolPrazno {
    if (i<0 || i>=niz.length) throw new GrePolIndeks(i);
    if (niz[i] == null)       throw new GrePolPrazno(i);
    Predmet p = niz[i]; niz[i] = null; q -= p.Q(); 
    return p;
  }

  public Predmet dohvati(int i)      // Dohvatanje na datom mestu.
    throws GrePolIndeks, GrePolPrazno {
    if (i<0 || i>=niz.length) throw new GrePolIndeks(i);
    if (niz[i] == null)       throw new GrePolPrazno(i);
    return niz[i];
  }
  
  public boolean prazno(int i) throws GrePolIndeks {     // Da li je mesto
    if (i<0 || i>=niz.length) throw new GrePolIndeks(i); //    prazno?
    return niz[i] == null;
  }

  public int kapacitet() { return niz.length; } // Kapacitet police.
  
  public int slobodno() {                       // Broj slobodnih mesta.
    int k = 0;
    for (int i=0; i<niz.length; i++) if (niz[i] == null) k++;
    return k;
  }

  public int zauzeto()                          // Broj zauzetih mesta.
    { return kapacitet() - slobodno(); }

  public double nosivost() { return maxQ; }     // Nosivost police.

  public double teret() { return q; }           // Ukupan teret na polici.

  public double jo() { return maxQ - q; }      // Dozvoljeni dodatni teret.

  @Override
  public String toString() {                    // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<niz.length; i++)
      if (niz[i] != null)
        sb.append(i).append(". ").append(niz[i]).append('\n');
    return sb.toString();
  }
  
  public Polica prazni() {                      // Pranjenje police.
    for (int i=0; i<niz.length; niz[i++]=null);
    q = 0;
    return this;
  }
}
