// Sklop.java - Klasa sklopova predmeta.

package predmeti2;
import  lista2.*;

public class Sklop extends Predmet {

  private Lista lst = new Lista();            // Lista sadranih predmeta.

  public Sklop dodaj(Predmet p)               // Dodavanje predmeta.
    { lst.dodaj(p);  return this; }
 
  public Predmet dohvati(int ind) {           // Dohvatanje predmeta.
    lst.naPrvi();
    for (int i=1; i<ind; i++) lst.naSledei();
    try { return (Predmet)lst.dohvatiTek(); }
      catch (GreLstNemaTek g) { return null; }
  }

  @Override
  public final double V() {                     // Zapremina.
    double V = 0;
    for (lst.naPrvi(); lst.imaTek(); lst.naSledei())
      try { V += ((Predmet)lst.dohvatiTek()).V(); }
        catch (GreLstNemaTek g) {}
    return V;
  }

  @Override
  public final double Q() {                     // Teina.
    double Q = 0;
    for (lst.naPrvi(); lst.imaTek(); lst.naSledei())
      try { Q += ((Predmet)lst.dohvatiTek()).Q(); }
        catch (GreLstNemaTek g) {}
    return Q;
  }

  @Override
  public Sklop clone() {                        // Stvaranje kopije.
    Sklop s = (Sklop)super.clone();
    s.lst = new Lista();
    for (lst.naPrvi(); lst.imaTek(); lst.naSledei())
      try {
        Predmet p = (Predmet)lst.dohvatiTek();
        s.dodaj(p.clone());
      } catch (GreLstNemaTek g) {}
    return s;
  }

  private static int nivo = 0;                  // Nivo uklapanja predmeta.

  private static void uvuci(StringBuilder sb) { // Uvlaenje uklopljenih
    for (int i=0; i<nivo; i++) sb.append("  "); //   predmeta u tekstu-
  }                                             //   alnom opisu.

  @Override
  public String toString() {                    // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    sb.append(super.toString()).append(" {\n");
    nivo++;
    for (lst.naPrvi(); lst.imaTek(); lst.naSledei()) {
      try {
        Predmet p = (Predmet)lst.dohvatiTek();
        uvuci(sb); sb.append(p).append('\n');
      } catch (GreLstNemaTek g) {}
    }
    nivo--;
    uvuci(sb); return sb.append('}').toString();
  }
}
