// Paket.java - Klasa paketa.

package prevoz;

public class Paket extends Roba {
  private Roba[] robe;                             // Robe u paketu.
  private int n;                                   // Broj roba.
  
  public Paket(int kap) { robe = new Roba [kap]; } // Inicijalizacija.
  
  public Paket dodaj(Roba r) throws GrePun {       // Dodavanje robe.
    if (n == robe.length) throw new GrePun();
    robe[n++] = r;
    return this;
  }
 
  @Override
  public double vrednost() {                       // Vrednost paketa.
    double v = 0;
    for (int i=0; i<n; v+=robe[i++].vrednost());
    return v;
  }

  @Override
  public double teina() {                         // Teina paketa.
    double t = 0;
    for (int i=0; i<n; t+=robe[i++].teina());
    return t;
  }
  
  @Override
  public Paket clone() {                           // Kopija paketa.
    Paket p = (Paket)super.clone();
    p.robe = robe.clone();
    for (int i=0; i<n; i++) p.robe[i] = robe[i].clone();
    return p;
  }

  @Override
  public String toString() {                       // Tekstualni opis.
    String s = "[";
    for (int i=0; i<n; i++) {
      if (i > 0) s += ",";
      s += robe[i];
    }
    return s + "]";
  }
}
