// Histogram.java - Klasa prikazivaa nizova u obliku histograma.

package prikazivai;
import java.awt.*;
import java.awt.event.*;

public class Histogram extends Dialog implements Prikaziva {

  private class Platno extends Canvas {              // Klasa platna:
    Platno() {                                       // - inicijalizacija,
      addComponentListener(new ComponentAdapter() {     // - obrada promene
        @Override                                       //   veliine
        public void componentResized(ComponentEvent dog)//   platna,
          { repaint() ; }
      });
    }

    @Override
    public void paint(Graphics g) {                     // - crtanje po
      if (niz != null) {                                //   platnu.
        g.setColor(Color.BLACK);
        int ir = getWidth(), vis = getHeight();
        int n = niz.length;
        double max = niz[0];
        for (int i=1; i<n; i++) if (niz[i] > max) max = niz[i];
        double ds = (double)ir / n, dv = (double)vis / max;
        for (int i=0; i<n; i++) {
          int x = (int)(i * ds), v = (int)(niz[i] * dv);
          g.fillRect(x, vis-v, (int)ds-1, v);
        }
      }
    }
  } // class Platno

  private Platno platno = new Platno();         // Platno po kome se crta.
  private double[] niz;                         // Niz za prikazivanje.

  public Histogram(Frame vlasnik, String naslov,   // Sastavljanje prozora:
                   int x, int y, int ir, int vis) {
    super(vlasnik, naslov);
    setBounds(x, y, ir,vis);
    add(platno);
    addWindowListener(new WindowAdapter() {        // - obrada zatvaranja
      @Override                                    //   prozora.
      public void windowClosing(WindowEvent dog)
        { dispose(); }
    });
  }

  @Override
  public void prikai(double[] niz)                // Prikzaivanje niza.
    { this.niz = niz; platno.repaint(); }

  @Override
  public String toString() { return "histogram"; } // Vrsta prikazivaa.
}
