// Prozor.java - Klasa prikazivaa nizova u prozoru.

package prikazivai;
import java.awt.*;
import java.awt.event.*;

public class Prozor extends Dialog implements Prikaziva {
  private TextArea tks = new TextArea();           // Komponenta za prikaz.
  private String frm;                              // Format prikazivanja.
  private double[] niz;                            // Prikazivani niz.

  public Prozor(Frame vlasnik, String naslov,      // Sastavljanje prozora:
                 int x, int y, int ir, int vis, String frm) {
    super(vlasnik, naslov); this.frm = frm;
    setBounds(x, y, ir, vis);
    add(tks);
    tks.addComponentListener(new ComponentAdapter() { // - obrada promene
      @Override                                       //   veliine polja
      public void componentResized(ComponentEvent dog)//   za tekst,
        { prikai(niz); }
    });
    addWindowListener(new WindowAdapter() {           // - obrada zatvaranja
    @Override                                         //   prozora.
      public void windowClosing(WindowEvent dog)
        { dispose(); }
    });
  }

  @Override
  public void prikai(double[] niz) {              // Prikazivanje niza.
    if (niz != null) {
      this.niz = niz;
      Graphics g = getGraphics();
      if (g != null) {
        FontMetrics  fm = g.getFontMetrics();
        StringBuilder sb = new StringBuilder();
        int p = 0;
        for (double br: niz) {
          String s = String.format(frm, br);
          int k = fm.stringWidth(s);
          if (p+k >= getWidth()-30) { sb.append('\n'); p = 0; }
          sb.append(s); p += k;
        }
        tks.setText(sb.toString());
      }
    }
  }

  @Override
  public String toString() { return "prozor"; }    // Naziv prikazivaa.
}
