// Frima.java - Klasa firmi.

package prodaja;

public class Firma {
  private Radnik[] radnici;                     // Niz radnika.
  private double mara;                         // Mara poslovanja.
  public Firma(double m, int kap) {             // Inicijalizacija.
    mara = m;
    radnici = new Radnik [kap];
  }
  public boolean zaposli(Radnik r) {            // Zapoljavanje radnika.
    int i=0; while (i<radnici.length && radnici[i]!=null) i++;
    if (i == radnici.length) return false;
    radnici[i] = r;
    return true;
  }

  public boolean otpusti(int i) {               // Otputanje radnika.
    if (i<0 || i>=radnici.length || radnici[i]==null)
      return false;
    radnici[i] = null;
    return true;
  }
  
  public double dobit() {                       // Dobit firme.
    double ukPrihod = 0, ukPlata = 0;
    for (int i=0; i<radnici.length; i++)
      if (radnici[i] != null) {
        if (radnici[i] instanceof Prodavac)
          ukPrihod += radnici[i].prihod();
        ukPlata += radnici[i].plata();
      }
    return ukPrihod * mara / 100 - ukPlata;
  }
  
  @Override
  public String toString() {                    // Tekstualni opis.
    String s = "";
    for (int i=0; i<radnici.length; i++)
      if (radnici[i] != null) s += radnici[i] + "\n";
    return s + "Dobit firme: " + dobit();
  }
}
