// Radnik.java - Klasa radnika.

package radionica;
import  predmeti1.Predmet;

public class Radnik {

  private static int posId = 0;   // Poslednji identifikator.
  private final int id = ++posId; // Identifikator radnika.
  private String ime;             // Ime radnika.
  private Maina ma;             // Maina koju radnik koristi.
  private int br;                 // Broj napravljenih proizvoda na maini.

  public Radnik(String iime) { ime = iime; } // Inicijalizacija.

  public int dohvatiId() { return id; }      // Dohvatanje identifikatora
  public String dohvatiIme() { return ime; } //   i imena.

  public Radnik rasporedi(Maina m)          // Rasporeivanje na mainu.
    { ma = m; br = 0; return this; }

  public Maina dohvatiMa() { return ma; } // Dohvatanje maine.

  public int broj() throws GreNemaMa {             // Broj napravljenih
    if (ma == null) throw new GreNemaMa(ime, id); //   predmeta.
    return br;
  }

  public Predmet napravi() throws GreNemaMa {      // Pravljenje predmeta.
    if (ma == null) throw new GreNemaMa(ime, id);
    br++; 
    return ma.napravi();
  }
 
  @Override
  public String toString() {                 // Tekstualni opis.
    String s = ime + "/" + id;
    if (ma != null) s += "(" + ma.vrsta() + "," + br + ")";
    return s;
  }
}
