// PokRadnik.java - Klasa pokretnih radnika.

package radnja;
import  radionica.*;
import  pokretni.Pokretan;
import  polica2.*;
import  predmeti1.*;

public class PokRadnik extends Radnik implements Pokretan {
  
  private Polica  pol;         // Odredina polica.
  private double  maxT;        // Najdue vreme proizvodnje predmeta.
  private double  t;           // Preostalo vreme do narednog dogaaja.
  private Predmet pred;        // Sledei proizvedeni predmet.
 
  public PokRadnik(String ime, double tMax, Polica p) // Inicijalizacija.
    { super(ime); pol = p; maxT = tMax; }
  public PokRadnik(String ime, double tMax) { this(ime, tMax, null); }

  public PokRadnik polica(Polica p)          // Pridruivanje police.
    { pol = p; return this; }
  
  @Override
  public Pokretan proteklo(double dt) {      // Sledei korak rada.
    if ((t -= dt) <= 0) {
      try {
        if (pred != null) {
          if (pol == null) throw new GreRadNemaPol(this);
          pol.stavi(pred);
          System.out.println("Radnik " + this + " je stavio " + pred);
        }
        pred = napravi();
        t = Math.random() * maxT;
      } catch (GrePolica g) {
        System.out.println("Radnik " + this + " je zatekao punu policu");
      } catch (usluge.Greka g) {
        System.out.println(g);
      }
    }
    return this;
  }
}
