// Radnja.java - Klasa radnji.

package radnja;
import  polica2.Polica;
import  pokretni.Pokretan;
import  radionica.Maina;
import  predmeti1.Predmet;
import  lista2.Lista;

public class Radnja {
  
  private Maina[] maine = new Maina [10];   // Maine za proizvodnju.
  private int brMa;                           // Broj maina.
  private Polica polica;                       // Polica s artiklima.
  private asovnik asovnik = new asovnik();  // Generator takta.
  private Lista kupci = new Lista();           // Kupci u radnji.
 
  public Radnja(                       // Inicijalizacija:
                 double maxQ,          // - nosivost police,
                 int kap,              // - broj mesta na polici,
                 double maxUlaz,       // - najdue vreme do ulaska kupca,
                 double maxKup         // - najdue vreme kupovine.
                ) {
    polica = new Polica(kap, maxQ);
    asovnik.dodaj(new Ulaz(maxUlaz));
    asovnik.dodaj(new Prodavac(maxKup));
  }

  public Radnja dodajMa(Maina ma)           // Nabavka maine.
    { maine[brMa++] = ma; return this; }
    
  public Radnja zaposli(PokRadnik radnik) {    // Zapoljavanje radnika.
    asovnik.dodaj(radnik);
    radnik.polica(polica);
    radnik.rasporedi(maine[(int)(Math.random() * brMa)]);
    System.out.println("Zaposlen je radnik " + radnik);
    return this;
  }
                                               // Otputanje radnika.
  public Radnja otpusti(PokRadnik radnik) throws GreRadNemaRad {
    try { asovnik.izbaci(radnik); }
      catch (GreasNemaKli g) { throw new GreRadNemaRad(radnik); }
    return this;
  }

  public void radi(double dt, double maxT)     // Radno vreme radnje.
    { asovnik.radi(dt, maxT); }
 
  private class Ulaz implements Pokretan{// UNUTRANJA KLASA ULAZA U RADNJU.

    private double maxT;        // Najdue vreme do ulaska kupca.
    private double t;           // Preostalo vreme do narednog dogaaja.
    private Kupac  kup;         // Sledei kupac koji ulazi.
  
    private Ulaz(double tMax) { maxT = tMax; } // Inicijalizacija.
  
    @Override
    public Pokretan proteklo(double dt) {      // Sledei korak rada.
      if ((t -= dt) <= 0) {
        try {
          if (kup != null) {
            kupci.dodaj(kup);
            System.out.println("Kupac  " + kup + " je uao");
          }
          int i = (int)(Math.random() * brMa);
          kup = new Kupac(maine[i].vrsta());
          t = Math.random() * maxT;
        } catch (Exception g) {}
      }
      return this;
    }
  } // class Ulaz
  
  private class Prodavac implements Pokretan { // UNUTRANJA KLASA PRODAVCA.

    private double maxT;       // Najdue vreme kupovine.
    private double t;          // Preostalo vreme do narednog dogaaja.
    private Kupac  kup;        // Kupac koji kupuje.
  
    private Prodavac(double tMax) { maxT = tMax; } // Inicijalizacija.

    @Override
    public Pokretan proteklo(double dt) {          // Sledei korak rada.
      if ((t -= dt) <= 0) {
        if (kup != null) {
          int i; Predmet p = null;
          for (i=0; i<polica.kapacitet(); i++)
            try {
              if ((p = polica.dohvati(i)).vr() == kup.dohvatiVrs())
                break;
            } catch (Exception g) {}
          if (p != null) try { polica.uzmi(i); } catch (Exception g) {}
          kup.usluzen(p);
          kup = null;
        }
        try {
          kup = (Kupac)kupci.naPrvi().dohvatiTek();
          kupci.izbaci(kup);
          t = Math.random() * maxT;
        } catch (usluge.Greka g) {}
      }
      return this;
    }
  } // class Prodavac
} // class radnja.Radnja
