// Renik.java - Klasa renika.

package renik1;

class Elem {                            // Element liste odrednica:
  Odrednica odred;                      // - odrednica,
  Elem sled;                            // - sledea odrednica,
  
  Elem(Odrednica odr, Elem s)           // - stvaranje elementa.
    { odred = odr; sled = s; }
}

public class Renik {                   // KLASA RENIKA:
  Elem prvi = null;                     // Poetak liste.

  public boolean dodaj(Odrednica odr) { // Dodavanje nove odrednice.
    Elem tek = prvi, pret = null;
    while (tek!=null && tek.odred.ispred(odr))
       { pret = tek; tek = tek.sled; }
    if (tek!=null && tek.odred.isti(odr)) return false;
    Elem novi = new Elem(odr, tek);
    if (pret == null) prvi = novi; else pret.sled = novi;
    return true;
  }
  
  public String[] prevodi(String poj) { // Svi prevodi pojma.
    Elem tek = prvi;
    while (tek!=null && tek.odred.pojam().compareTo(poj)<0)
      tek = tek.sled;
    String s = "";
    while (tek!=null && tek.odred.pojam().equals(poj)) {
      s += tek.odred.prevod() + "\0";
      tek = tek.sled;
    }
    return s.split("\0");
  }
  
  public String toString() {            // Tekstualni opis renika.
    String s = "";
    for(Elem tek=prvi; tek!=null; tek=tek.sled)
      s += tek.odred + "\n";
    return s;
  }
}
