// Kasa.java - Klasa kasa samoposluge.

package samoposluga;
import  usluge.Polje;
import  java.awt.Color;

class Kasa extends Thread {

  private static int posId = 0;           // Poslednji identifikator.
  private final int id = ++posId;         // Identifikator kase.
  private int maxNaplata;                 // Najdue vreme naplaivanja.
  private Polje polje;                    // Polje za prikaz stanja kase.
  private Red red;                        // Red ispred kase.
  private boolean radi = true;            // Da li radi?

  Kasa(Samoposluga samop, int maxNapl, Polje p, Polje pRed) { // Inicijali-
    maxNaplata  = maxNapl;                                    //    zacija.
    red = new Red(pRed);
    if ((polje = p) != null) {
      polje.komponenta().setForeground(Color.BLACK);
      polje.pii("Kasa" + id);
    }
    start();
  }
 
  @Override
  public void run() {                     // Telo niti.
    try {
      while (!interrupted()) {
        synchronized (this) { if (!radi) wait(); }
        Kupac kupac = red.uzmi();
        if (polje != null) polje.pii("Kasa" + id + ": " + kupac.id());
        sleep((long)(Math.random() * maxNaplata));
        kupac.naplaceno();
        if (polje != null) polje.pii("Kasa" + id);
      }
    } catch (InterruptedException g) {}
  }

  synchronized void zatvori() {           // Zatvaranje kase.
    radi = false;
    if (polje != null) polje.komponenta().setForeground(Color.RED);
  }

  synchronized void otvori() {            // Otvaranje kase.
    radi = true; notify();
    if (polje != null) polje.komponenta().setForeground(Color.BLACK);
  }

  void staviURed(Kupac kupac)             // Stavljanje kupca u red.
    { red.stavi(kupac); }
  
  int id() { return id; }                 // Dohvatanje identifikatora kase.
}
