// Kupac.java - Klasa kupaca samoposluge.

package samoposluga;

class Kupac extends Thread {

  private static int posId = 0;   // Poslednji identifikator.
  private final int id = ++posId; // Identifikator kupca.
  private int maxKupovina;        // Najdue vreme biranja robe.
  private Samoposluga samoposl;   // Samoposluga u kojoj se nalazi.

  Kupac(Samoposluga samop, int maxKup)            // Inicijalizacija.
    { samoposl = samop; maxKupovina = maxKup; start(); }

  @Override
  public void run() {                             // Telo niti:
    try {
      samoposl.uaoKupac();                       // - ulazak u samoposlugu,
      sleep((long)(Math.random() * maxKupovina)); // - izbor robe,
      Kasa[] kase = samoposl.dohvatiKase();       // - izbor kase,
      Kasa kasa = kase[(int)(Math.random() * kase.length)];
      kasa.staviURed(this);                       // - ulazak u red,
      synchronized (this) { wait(); }             // - ekanje u redu,
      samoposl.izasaoKupac();                     // - izlazak iz samoposl.
    } catch (InterruptedException g) {}
  }

  synchronized void naplaceno(){ notify(); } // Dojava da je roba naplaena.

  int id() { return id; }                    // Dohvatanje identifikatora.
}
