// Red.java - Klasa reda kupaca.

package samoposluga;
import  usluge.Polje;
import  java.util.LinkedList;

class Red {

  private LinkedList<Kupac> kupci         // Kupci u redu.
    = new LinkedList<>();
  private Polje polje;                    // Polje za prikaz stanja reda.

  Red(Polje p) { polje = p; }             // Dohvatanje pridruenog polja.

  synchronized void stavi(Kupac kupac) {  // Stavljanje kupca u red.
    kupci.addLast(kupac); notifyAll();
    if (polje != null) polje.pii(this);
  }

  synchronized Kupac uzmi() throws InterruptedException { // Vaenje prvog
    while (kupci.isEmpty()) wait();                       //   kupca iz reda
    Kupac kupac = kupci.removeFirst();
    if (polje != null) polje.pii(this);
    return kupac;
  }

  @Override
  public synchronized String toString() { // Tekstualni opis sadraja reda.
    StringBuilder sb = new StringBuilder();
    for (var kupac : kupci)
      sb.append(kupac.id()).append('\n');
    return sb.toString();
  }
}
