// Ulaz.java - Klasa ulaza u samoposlugu.

package samoposluga;
	
import usluge.Polje;
import java.awt.Color;

class Ulaz extends Thread {

  private static int posId = 0;    // Poslednji identifikator.
  private final int id = ++posId;  // Identifikator ulaza.
  private int maxUlaz;             // Najdue vreme izmeu ulazaka kupaca.
  private int maxKupovina;         // Najdue vreme biranja robe.
  private Samoposluga samoposl;    // Vlasnika samoposluga.
  private Polje polje;             // Polje za prikaz stanja ulaza.
  private boolean radi = false;    // Da li radi?

  Ulaz(Samoposluga samop, int maxUl, int maxKup, Polje p) {  // Inicijali-
    samoposl = samop; maxUlaz = maxUl; maxKupovina = maxKup; //   zacija.
    if ((polje = p) != null) {
      polje.komponenta().setForeground(Color.RED);
      polje.pii("Ulaz" + id);
    }
    start();
  }
  @Override
  public void run() {                    // Telo niti.
    try {
      while (!interrupted()) {
        synchronized (this) { if (!radi) wait(); }
        sleep((long)(Math.random() * maxUlaz));
        Kupac kupac = new Kupac(samoposl, maxKupovina);
        if (polje != null) polje.pii("Ulaz" + id + ": " + kupac.id());
      }
    } catch (InterruptedException g) {}
  }

  synchronized void zatvori() {          // Zatvaranje ulaza.
    radi = false;
    if (polje != null) {
      polje.pii("Ulaz" + id);
      polje.komponenta().setForeground(Color.RED);
    }
  }

  synchronized void otvori() {           // Otvaranje ulaza.
    radi = true; notify();
    if (polje != null) polje.komponenta().setForeground(Color.BLACK);
  }

  int id() { return id; }                // Dohvatanje identifikatora ulaza.
}
