// Proizvod.java - Apstraktna klasa uporedivih proizvoda.

package skladite1;

public abstract class Proizvod implements Uporediv, Cloneable {
  
  public abstract char oznaka();                // Oznaka vrste proizvoda.

  public abstract double zapremina();           // Zapremina proizvoda.
  
  @Override
  public boolean istovetan(Uporediv u)          // Da li su istovetni?
    { return oznaka() == ((Proizvod)u).oznaka(); }
  
  @Override
  public Proizvod clone() {                     // Kopija proizvoda.
    try { return (Proizvod)super.clone(); }
      catch (CloneNotSupportedException g) { return null; }
  }
  
  @Override
  public String toString()                      // Tekstualni opis.
    { return Character.toString(oznaka()); }
}
