// Skladite.java - Klasa skladita proizvoda.

package skladite1;
import skladite1.greke.*;

public class Skladite {
  private Proizvod[] niz;             // Mesta za proizvode.
  private double maxZapr, trenZapr=0; // Dozvoljena i trenutna zapremina.

  public Skladite(int kap, double maxV)        // Inicijalizacija.
    { niz = new Proizvod [kap]; maxZapr = maxV; }
  
  public Skladite(double maxV) { this(10, maxV); }
                                                // Stavljanje proizvoda.
  public Skladite stavi(Proizvod p) throws GreZapremina, GreNemaMesta {
    if (trenZapr + p.zapremina() > maxZapr) throw new GreZapremina();
    int i=0; while (i<niz.length&&niz[i]!=null) i++;
    if (i == niz.length) throw new GreNemaMesta();
    niz[i] = p;
    trenZapr += p.zapremina();
    return this;
  }
                                                // Uzimanje proizvoda.
  public Proizvod uzmi(Proizvod p) throws GreNemaProizvoda {
    int i = 0; while (i<niz.length &&
      (niz[i]==null || !niz[i].istovetan(p))) i++;
    if (i == niz.length) throw new GreNemaProizvoda();
    p = niz[i]; niz[i] = null;
    trenZapr -= p.zapremina ();
    return p;
  }
  
  public int imaMesta() {                       // Broj slobodnih mesta.
    int k = 0;
    for (int i=0; i<niz.length; i++)
      if (niz[i] == null) k++;
    return k;
  }
                                                // Slobodna zapremina.
  public double imaZapr() { return maxZapr - trenZapr; }
}
