// Potroa.java - Klasa potroaa.

package skladite2;

public class Potroa extends Thread {
  
  private static int posId = 0;   // Poslednji identifikator.
  private final int id = ++posId; // Identifikator potroaa.
  private Skladite skladite;    // Pridrueno skladite.
  private int minVreme, maxVreme; // Najkrae i najdue vreme potronje.

  public Potroa(Skladite sklad, int minVr, int maxVr) { 
    minVreme = minVr; maxVreme = maxVr;              // Inicijalizacija.
    skladite = sklad;
  }
  
  public Potroa(Skladite sklad) { this(sklad, 1000, 2000); }
  
  @Override
  public void run() {                                // Telo niti.
    System.out.println("Potro " + id + " krenuo");
    try {
      while (!interrupted()) {
        int vredn = skladite.uzmi();
        System.out.println("Potro " + id + " uzeo    " + vredn);
        sleep((long)(minVreme + Math.random() * (maxVreme-minVreme)));
      }
    } catch (InterruptedException g) {}
    System.out.println("Potro " + id + " zavrio");
  }
}
