// Skladite.java  Klasa za uskladitavanje podataka.

package skladite3;
import  usluge.Polje;

public class Skladite {

  private static int posId = 0;   // Poslednji identifikator.
  private final int id = ++posId; // Identifikator skladita.
  private int[] niz;              // Niz za uskladitavanje podataka.
  private int ulaz, izlaz;        // Mesto stavljanja i uzimanja podatka.
  private int pun;                // Broj popunjenih mesta.
  private Polje polje;            // Polje za prikaz stanja skladita.

  public Skladite(int kap, Polje p)           // Inicijalizacija.
    { niz = new int [kap]; polje = p; }

  public Skladite(int kap) { this(kap, null); }

  public synchronized void stavi(int vredn) throws InterruptedException {
    while (pun == niz.length) wait();          // Stavljanje podatka.
    niz[ulaz++] = vredn; if (ulaz == niz.length) ulaz = 0;
    pun++; notifyAll();
    if (polje != null) polje.pii(this);
  }
  
  public synchronized int uzmi() throws InterruptedException {
    while (pun == 0) wait();                   // Uzimanje podatka.
    int vredn = niz[izlaz++];
    if (izlaz == niz.length) izlaz = 0;
    pun--;
    notifyAll();
    if (polje != null) polje.pii(this);
    return vredn;
  }

  @Override
  public synchronized String toString() {      // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<pun; i++)
      sb.append(niz[(izlaz+i) % niz.length]).append('\n');
    return sb.toString();
  }
}
