// Tabla.java - Klasa tabli.

package slagalica;
import java.awt.*;
import java.awt.event.*;

public class Tabla extends Panel {
  Button[] dugmad = new Button [16];            // Dugmad na tabli.
  private Button prazno;                        // Prazno dugme.
  private toperica toperica;                  // Koriena toperica.
  
  public Tabla(toperica topr) {               // Inicijalizacija.
    toperica = topr; 
    setLayout(new GridLayout(4, 4));
    setEnabled(false);
    for (int i=0; i<16; i++) {
      add(dugmad[i] = new Button());
      dugmad[i].addActionListener(oslukiva);
    }
  } 

  void postavi() {                              // Postavljanje table.
    toperica.stani();
    for (Button d: dugmad) d.setLabel(""); 
    for (int i=1; i<16; i++) {
      int k = 0;
      while (!dugmad[k = (int)(Math.random()*16)].getLabel().equals(""));
      dugmad[k].setLabel(Integer.toString(i));
    }
    int i = 0; while (!dugmad[i].getLabel().equals("")) i++;
    prazno = dugmad[i];
    setEnabled(true);
    toperica.kreni();
  }

  private ActionListener oslukiva = dog -> { // Oslukiva komandne
    Button dgm = ((Button)dog.getSource());    //   dugmadi:
    if (dgm != prazno) {                       // - premetanje natpisa na
      prazno.setLabel(dgm.getLabel());         //   prazno dugme,
      dgm.setLabel(""); prazno = dgm;
    }
    int i=0;                                   // - da li su natpisi ureeni
    while (i<15) {                             //   do kraja?
      if (dugmad[i]==prazno ||
          Integer.parseInt(dugmad[i].getLabel()) != i+1) break;
      i++;
    }
    if (i == 15) { setEnabled(false); toperica.stani(); }
  };
}
