// Grupa.java - Klasa grupe elektrinih potroaa.

package struja;

public class Grupa extends Potroa {

  private static class Elem {           // Element liste (ugneena klasa):
    Potroa potr;                      // - sadrani potroa,
    Elem sled;                          // - sledei element,
    Elem(Potroa p) { potr = p; }      // - inicijalizacija.
  }

  private Elem prvi, posl;                      // Poetak i kraj liste.
  private double snaga;                         // Snaga grupe potroaa.
  
  public Grupa dodaj(Potroa p) {              // Dodavanje potroaa.
    Elem novi = new Elem(p);
    if (prvi == null) prvi = novi; else posl.sled = novi;
    posl = novi;
    snaga += p.snaga();
    return this;
  }
  
  @Override
  public double snaga() { return snaga; }       // Snaga grupe potroaa.
  
  @Override
  public String toString() {                    // Tekstualni opis.
    String s = "[";
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      s += tek.potr;
      if (tek.sled != null) s += ",";
    }
    return s + "]";
  }
}
