// GraStaza.java - Klasa grafikih staza.

package trka;
import java.awt.Button;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class GraStaza extends Staza implements ActionListener {

  private Panel plo;               // Ploa pridruena stazi.
  private TextField tksDu =       // Polje za unos duine staze.
    new TextField(Double.toString(du), 8);
  private Button dgmKreni =        // Dugme za pokretanje trke.
    new Button("kreni");
  private Label oznPobednik =      // Natpis za prikaz pobednika.
    new Label();

  public GraStaza(double du, Panel plo)         // Inicijalizacija.
    { super(du); popuniPlou(plo); }

  public GraStaza(Panel plo)
    { super(); popuniPlou(plo); }

  private void popuniPlou(Panel plo) {          // Popunjavanje ploe.
    this.plo = plo;
    plo.add(new Label("duina:", Label.RIGHT));
    plo.add(tksDu);
    plo.add(dgmKreni);
    plo.add(oznPobednik);
    dgmKreni.addActionListener(this);
  }

  @Override
  public void actionPerformed(ActionEvent dog) { // Obrada pritisaka
    try {                                        //   dugmeta "kreni".
      du = Double.parseDouble(tksDu.getText());
      dgmKreni.setEnabled(false);
      oznPobednik.setText("");
      plo.validate();
      kreni();
    } catch (NumberFormatException g) {}
  }

  @Override
  protected void proveri() {                     // Provera kraja trke i
    super.proveri();                             //   prikaz vozila na elu.
    oznPobednik.setText
      ((gotova ? "Pobednik: " : "Vodi: ") + naelu().id());
    plo.validate();
    if (gotova) dgmKreni.setEnabled(true);
    for (Vozilo v : vozila) v.toString();
  }
}
