// GraVozilo.java - Klasa grafikih vozila.

package trka;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;

public class GraVozilo extends Vozilo {

  private Panel plo;               // Ploa pridruena vozilu.
  private TextField tksVmax =      // Polje za unos maksimalne brzine.
    new TextField(Double.toString(vmax), 3);
  private Label oznVozilo =        // Natpis za prikaz tekstualnog opisa.
    new Label(toString());

  public GraVozilo(double vmax, Panel plo)     // Inicijalizacija.
    { super(vmax); popuniPlou(plo); }

  public GraVozilo(Panel plo)
    { super(); popuniPlou(plo); }

  private void popuniPlou(Panel plo) {        // Popunjavanje ploe.
    this.plo = plo;
    plo.add(new Label("vmax:", Label.RIGHT));
    plo.add(tksVmax);
    plo.add(oznVozilo);
  }

  @Override
  public void kreni() {                        // Pokretanje vozila.
    try {
      postavi(Double.parseDouble(tksVmax.getText()));
      super.kreni();
    } catch (NumberFormatException g) {}
  }

  @Override
  public String toString() {                   // Prikaz tekstualnog opisa.
    String s = super.toString();
    if (oznVozilo != null) {
      oznVozilo.setText(s);
      plo.validate();
    }
    return s;
  }
}
