// Staza.java - Klasa aktivnih staza.

package trka;
import java.util.ArrayList;

public class Staza extends Thread {

  protected ArrayList<Vozilo> vozila           // Vozila na stazi.
      = new ArrayList<>();
  protected double du;                        // Duina staze.
  protected boolean gotova;                    // Da li je trka gotova?
  private boolean radi = false;                // Da li je nit aktivna?

  public Staza(double du) { this.du = du; } // Inicijalizacija.

  public Staza() { this(100000); }

  public Staza dodaj(Vozilo v)                 // Dodavanje vozila.
     { vozila.add(v); return this; }

  @Override
  public void run() {                          // Telo niti.
    try {
      while (!interrupted()) {
        if (!radi) synchronized (this) { wait(); }
        sleep(20); proveri();
      }
    } catch (InterruptedException g) {}
  }

  public void poni() { start(); }             // Pokretanje niti.

  public synchronized void kreni() {           // Poetak trke.
    for (Vozilo v : vozila) v.kreni();
    gotova = false; radi = true; notify();
  }

  protected void proveri() {                   // Provera zavretka trke.
    for (Vozilo v : vozila)
      if (v.s() >= du) { stani(); gotova = true; break; }
  }

  public Vozilo naelu() {                     // Vozilo na elu trke.
    double maxs = 0; Vozilo vodi = null;
    for (Vozilo v : vozila) {
      double s = v.s();
      if (s > maxs) { maxs = s; vodi = v; }
    }
    return vodi;
  }
 
  private synchronized void stani() {          // Zaustavljanje vozila.
    radi = false;
    for (Vozilo v : vozila) v.stani();
  }
}
