// Trka.java - Program za organizovanje trke na grafikoj povri.

package trka;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Trka extends Frame {

  private static final int BR_VOZILA = 5;  // Broj vozila u trci.
  private Staza staza;                     // Staza za trku.
  private ThreadGroup niti;                // Niti u prozoru.

  private void popuniProzor() {            // Popunjavanje prozora:
    Panel plo = new Panel();               // - ploa za upravljanje trkom,
    add(plo, "South");
    (staza = new GraStaza(plo)).poni();
                                 
    add(plo = new Panel(new GridLayout(0, 1)), "Center");  // - ploa za
    for (int i=0; i<BR_VOZILA; i++) {                      //   prikaz
      Panel p = new Panel(); plo.add(p);                   //   vozila.
      Vozilo v = new GraVozilo(p); v.poni();
      staza.dodaj(v);
    }
  }

  public Trka() {                          // Inicijalizacija.
    super("Trka");
    setSize(300, 200);
    popuniProzor();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog)
        { niti.interrupt(); dispose(); }
    });
    niti = Thread.currentThread().getThreadGroup();
  }
                                         
  public static void main(String[] varg)   // Glavna metoda.
    { new Trka(); }
}
