// NizZnakova.java - Klasa nizova uporedivih znakova.

package ureivanje;

public class NizZnakova {
  private Znak[] niz;                              // Sadrani niz.

  public NizZnakova(int n)                         // Inicijalizacija.
    { niz = new Znak [n]; puni();  }
                                                     // Popunjavanje niza.
  public void puni(Znak p, Znak q) throws GreOpseg { // - zadatim opsegom,
    if (q.manji(p)) throw new GreOpseg();
    for (int i=0; i<niz.length; i++)
      niz[i] = new Znak(
        (char)(p.znak() + Math.random()*(q.znak()-p.znak()+1))
      );
  }

  public void puni() {                               // - podrazumevanim
    try { puni(new Znak('a'), new Znak('z')); }      //   opsegom.
      catch (GreOpseg g) {}
  }

  public void uredi(Ureiva u)                      // Ureivanje niza.
    { u.uredi(niz); }

  @Override
  public String toString() {                         // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<niz.length; i++) {
      sb.append(niz[i].znak());
      if (i%50==49 || i==niz.length-1)
        sb.append('\n');
    }
    return sb.toString();
  }
}
