// Ureiva.java  Apstraktna klasa za algoritme ureivanja.

package ureivai2;
import prikazivai.Prikaziva;

public abstract class Ureiva implements Runnable {

  protected Prikaziva prik = null;      // Korieni prikaziva.
  protected double[] niz;                // Niz koji se ureuje.
  private boolean prekini = false;       // Indikator prekidanja.
  private long dt = 10;                  // Trajanje pauze.
  private Thread nit = null;             // Nit koja radi.

  protected class GrePrekinut       // Klasa za prijavu prekidanja postupka.
            extends Exception {}

  public void postaviPrikazivaa(Prikaziva prik)    // Postavljanje
    { this.prik = prik; }                            //   prikazivaa.
  public void postaviDt(long dt)                     // Postavljanje
    { this.dt = dt; }                                //   kanjenja.

  public synchronized void uredi(double[] niz) {     // Zahtev za
    this.niz = niz;                                  //   ureivanje niza.
    (nit = new Thread(this)).start();
  }

  @Override
  public void run() {                                // Sadraj niti.
    prekini = false;
    try { prikai(); uredi(); } catch (GrePrekinut g) {}
    nit = null;
  }

  protected abstract void uredi() throws GrePrekinut;// Ureivanje niza.

  public void prekini() {                            // Zahtev za
    prekini = true;                                  //   prekidanje rada.
    if (nit != null) try { nit.join(); } catch (InterruptedException g) {}
  }

  protected void prikai() throws GrePrekinut {      // Prikazivanje niza.
    if (prik != null) prik.prikai(niz);
    try { Thread.sleep(dt); }
      catch (InterruptedException g) { prekini(); }
    if (prekini) throw new GrePrekinut();
  }

  @Override
  public abstract String toString();                 // Naziv algoritma.
}
