// Polje.java - Polje grafike korisnike povri za unos i prikaz podataka.

package usluge;
import  java.awt.*;

public class Polje {
  
  private Component komp;              // Pridruena grafika komponenta.
  private int ind;                     // Indeks stavke u komponenti.
  
  public Polje(Component k, int i)     // Inicijalizacija.
    throws GreKompNeOdgovara {
    if (!(k instanceof Label)         && 
        !(k instanceof TextComponent) &&
        !(k instanceof List)
       ) throw new GreKompNeOdgovara(k);
    komp = k; ind = i;
  }
  public Polje(Component k) 
    throws GreKompNeOdgovara { this(k, -1); }
    
  public Component komponenta()  // Dohvatanje sadrane komponente.
    { return komp; }
    
  public int indeks()            // Dohvatanje indeksa pridruene stavke.
    { return ind; }
                                       // PRIKAZIVANJE PODATAKA:
  public void pii(String tekst) {     // - String,
    if      (komp instanceof Label) 
      ((Label)komp).setText(tekst);
    else if (komp instanceof TextComponent)
      ((TextComponent)komp).setText(tekst);
    else if (komp instanceof List)
      ((List)komp).replaceItem(tekst, ind);
    komp.revalidate();
  }
  
  public void pii(long broj)          // - long,
    { pii(Long.toString(broj)); }
  
  public void pii(long broj, int baza)
    { pii(Long.toString(broj, baza)); }

  public void pii(double broj)        // - double,
    { pii(Double.toString(broj)); }

  public void pii(boolean b)          // - boolean,
    { pii(Boolean.toString(b)); }
    
  public void pii(char znak)          // - char,
    { pii(Character.toString(znak)); }

  public void pii(Object o)           // - Object.
    { pii(o.toString()); }
                                       // UZIMANJE PODATAKA:
  public String String() {             // - String,
    if      (komp instanceof Label) 
      return ((Label)komp).getText();
    else if (komp instanceof TextComponent)
      return ((TextComponent)komp).getText();
    else if (komp instanceof List)
      return ((List)komp).getItem(ind);
    else return null;
  }
 
  public long Long()                   // - long,
    { return Long.parseLong(String()); }
 
  public long Long(int baza)
    { return Long.parseLong(String(), baza); }
    
  public int Int()                     // - int,
    { return Integer.parseInt(String()); }
  
  public int Int(int baza)
    { return Integer.parseInt(String(), baza); }
    
  public short Short()                 // - short,
    { return Short.parseShort(String()); }
  
  public short Short(int baza)
    { return Short.parseShort(String(), baza); }

  public byte Byte()                   // - byte,
    { return Byte.parseByte(String()); }
  
  public byte Byte(int baza)
    { return Byte.parseByte(String(), baza); }
    
  public double Double()               // - double,
    { return Double.parseDouble(String()); }
  
  public float Float()                 // - float,
    { return Float.parseFloat(String()); }
  
  public boolean Boolean()             // - booelan,
    { return Boolean.parseBoolean(String()); }

  public char Char()                   // - char.
    { return String().charAt(0); }
}
