// Petarda.java - Apstraktna klasa petardi.

package vatromet;
import java.awt.*;

public abstract class Petarda extends Figura {

  private Vektor r0, v0;           // Vektor i poetnog poloaja i brzine.
  private long t0;                 // Vreme stvaranja petarde.
  protected Color boja;            // Boja petarde.
                                   // Inicijalizacija.
  public Petarda(Scena s, Vektor rr0, Vektor vv0, Color bboja) {
    super(s);
    r0 = rr0; v0 = vv0; boja = bboja;
    t0 = System.currentTimeMillis();
  }

  public Vektor poloaj() {        // Trenutni poloaj petrade.
    double t = (System.currentTimeMillis() - t0) / 1000.;
    return new Vektor(r0.x()+v0.x()*t, r0.y()+v0.y()*t-10*t*t);
  }

  @Override
  public void crtaj() {            // Zajedniki deo crtanja petarde.
    int ir = scena.getWidth();
    int vis = scena.getHeight();
    Vektor p = poloaj();
    int x = (int)p.x();
    int y = vis - (int)p.y();
    if (x>=0 && x<ir && y>=0 && y<vis) {
      Graphics g = scena.getGraphics();
      g.setColor(boja);
      crt(g, x, y);
    } else scena.izbaci(this);
  }
                                   // Specifini deo crtanja petarde.
  protected abstract void crt(Graphics g, int x, int y);
}
