// Scena.java - Klasa aktivnih scena.

package vatromet;
import java.awt.*;
import java.util.ArrayList;

public class Scena extends Canvas implements Runnable {

  private ArrayList<Figura> figure                // Figure u sceni.
    = new ArrayList<>();
  private Thread nit = new Thread(this);          // Nit scene.

  public Scena() { nit.start(); }                 // Inicijalizacija.

  public synchronized void dodaj(Figura fig)      // Dodavanje figure.
    { figure.add(fig); }
 
  public synchronized void izbaci(Figura fig) {   // Izbacivanje figure.
    figure.remove(fig);
  }
 
  @Override
  public synchronized void paint(Graphics g)      // Crtanje figura u sceni.
    { for (int i=figure.size()-1; i>=0; i--) figure.get(i).crtaj(); }

  @Override
  public void run() {                             // Telo niti.
    try {
      while (!Thread.interrupted()) { repaint(); Thread.sleep(20); }
    } catch (InterruptedException g) {}
  }
}
