// Vatromet.java - Klasa vatrometa.

package vatromet;
import java.awt.*;
import java.awt.event.*;

public class Vatromet extends Frame {

  private Scena scena = new Scena();             // Scena po kojoj se crta.
  private Top[] topovi = new Top [3];            // Niz topova.
  private ThreadGroup niti;                      // Niti u vatrometu.

  private void popuniProzor() {                  // Popunjavanje prozora:
    add(scena, "Center");                        // - scena za crtanje,
    scena.addComponentListener(new ComponentAdapter() {
      @Override                                  // - rasporeivanje topova
      public void componentResized(ComponentEvent dog){ //   pri promeni
        for (int i=0; i<topovi.length; i++)             //   veliine scene,
          topovi[i].premesti(new Vektor(
            scena.getWidth()*(2*i+1)/(2*topovi.length),
            0
          ));
      }
    });

    Panel plo = new Panel(); add(plo, "South");  // - ploa za dugmad,
    plo.setBackground(Color.GRAY);
    Button dgm = new Button("Kreni"); plo.add(dgm);
    dgm.addActionListener(dog -> {               // - pokretanje topova,
      for (Top top: topovi) top.kreni();
    });
    plo.add(dgm = new Button("Stani"));
    dgm.addActionListener(dog -> {               // - zaustavljanje topova.
      for (Top top: topovi) top.stani();
    });
  }

  public Vatromet() {                             // Inicijalizacija:
    super("Vatromet");
    setSize(300, 200);
    popuniProzor();                               // - popunjavanje prozora,
    for (int i=0; i<topovi.length; i++)           // - stvaranje topova,
      topovi[i] =  new Top(scena, new Vektor(0, 0));
    setVisible(true);
    addWindowListener(new WindowAdapter() {       // - obrada zatvaranja
      @Override                                   //   prozora.
      public void windowClosing(WindowEvent dog) {
        niti.interrupt(); dispose();
      }
    });

    niti = Thread.currentThread().getThreadGroup();
  }

  public static void main(String[] varg)          // Glavna metoda.
    { new Vatromet(); }
}
