// Vekt.java - Klasa vektora realnih brojeva.

package vektor1;

public class Vekt {
  
  int min, max;                                  // Granice indeksa.
  double[] niz;                                  // Niz komponenata.
                                                 // Inicijalizacija:
  public Vekt(int mi, int ma) throws GreVekt {   // - zadati opseg,
    if (mi > ma) throw new GreVekt(GreVekt.OPSEG);
    niz = new double [(max=ma) - (min=mi) + 1];
  }
  
  public Vekt(int ma) throws GreVekt             // - zadata gornja granica,
    { this(1, ma); }
  
  public Vekt() throws GreVekt { this(1, 10); }  // - podrazumevani opseg.

  public Vekt postavi(int i, double b) throws GreVekt {    // Postavljanje
    if (i<min || i>max) throw new GreVekt(GreVekt.INDEKS); //   komponente.
    niz[i-min] = b;
    return this;
  }
  
  public double dohvati(int i) throws GreVekt {    // Dohvatanje komponente.
    if (i<min || i>max) throw new GreVekt(GreVekt.INDEKS);
    return niz[i-min];
  }
  
  public static double skalPro(Vekt v1, Vekt v2) // Skalarni proizvod.
    throws GreVekt {
    if (v1.niz.length != v2.niz.length) throw new GreVekt(GreVekt.DUINA);
    double s = 0;
    for (int i=0; i<v1.niz.length; s+=v1.niz[i]*v2.niz[i++]);
    return s;
  }

  public int minInd() { return min; }            // Dohvatanje najmanjeg
  public int maxInd() { return max; }            //   i najveeg indeksa.
}
