// Veri.java - Klasa verinih razlomaka.

package veri;

public class Veri {
  
  double[] a;                                    // Koeficijenti razlomka.
  
  public Veri(int n) { a = new double [n]; }    // Inicijalizacija.
  
  public Veri postavi(int i, double b) throws GreVerInd {   // Postavljanje
    if (i<0 || i>=a.length) throw new GreVerInd(a.length, i);//   koefici-
    a[i] = b;                                                //   jenta.
    return this;
  }
  
  public double vr(double x) throws GreVerNula { // Vrednost razlomka.
    double s = 0;
    for (int i=a.length-1; i>=0; i--) {
      if (x + s == 0) throw new GreVerNula();
      s = a[i] / (x + s);
    }
    return s;
  }
  
  @Override
  public String toString() {                     // Tekstualni opis.
    String s = "Veri[";
    for (int i=0; i<a.length; i++) {
      if (i > 0) s += ",";
      s += a[i];
    }
    return s + "]";
  }
}
