// Teret.java - Apstraktna klasa tereta.

package voz;

public abstract class Teret {
  
  private static int posId = 0;        // Poslednji identifikator.
  private final int id;                // Identifikator tereta.
  private double sigma;                // Specifina teina.

  Teret(double s)                      // Nov objekat dobija nov
    { id = ++posId; sigma = s; }       //   identifikator.

  public abstract char vrsta();        // Oznaka vrste.
  
  public abstract double zapr();                         // Zapremina.
  
  public double teina() { return zapr() * sigma; }      // Teina.
  
  @Override                                              // Tekstualni opis.
  public String toString() { return "" + vrsta() + id; }
}
