// Vagon.java - Klasa vagona.

package voz;

public class Vagon extends Vozilo {

  private Niz<Teret> tereti;                    // Niz tereta.

  public Vagon(double st, int k)                // Inicijalizacija.
    { super(st); tereti = new Niz<Teret>(k); }

  public Vagon dodaj(Teret t) throws GrePun     // Dodavanje tereta.
    { tereti.dodaj(t); return this; }
  
  @Override
  public double ukTeina() {                    // Ukupna teina.
    double t = super.ukTeina();
    try {
      for (int i=0; i<tereti.duina(); i++)
        t += tereti.dohvati(i).teina();
    } catch (GreIndeks g) {}
    return t;
  }

  @Override
  public double vunaSila() { return 0; }       // Vuna sila.
 
  @Override
  public String toString() {                    // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    sb.append("V(").append(ukTeina()).append("|");
    try {
      for (int i=0; i<tereti.duina(); i++) {
        if (i > 0) sb.append(",");
        sb.append(tereti.dohvati(i));
      }
    } catch (GreIndeks g) {}
    return sb.append(")").toString();
  }
}
