// Voz.java - Klasa vozova.

package voz;

public class Voz {

  Niz<Vozilo> vozila;                           // Niz vozila.

  public Voz(int k) { vozila = new Niz<Vozilo>(k); } // Inicijalizacija.
  
  public int duina() { return vozila.duina(); }    // Duina voza.

  public boolean preopt(Vozilo v) {             // Da li bi se preopteretio?
    double teret = 0, sila = 0;
    try {
      for (int i=0; i<vozila.duina(); i++) {
        Vozilo w = vozila.dohvati(i);
        teret += w.ukTeina();
        sila  += w.vunaSila();
      }
    } catch (GreIndeks g) {}
    return teret + v.ukTeina() > sila + v.vunaSila();
  }
  
  public Voz dodaj(Vozilo v) throws GrePreopt, GrePun { // Dodavanje vozila.
    if (preopt(v)) throw new GrePreopt();
    vozila.dodaj(v);
    return this;
  }

  @Override
  public String toString() {                    // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    try {
      for (int i=0; i<vozila.duina(); i++)
        sb.append(vozila.dohvati(i)).append("\n");
    } catch (GreIndeks g) {}
    return sb.toString();
  }
}
