// Igra.java - Klasa igara XoX-a.

package xox;
import java.awt.Label;

public class Igra extends Thread {
  private Igra[] igrai = new Igra [2];      // Igrai.
  private int tekIgra;                        // Igra na potezu.
  private Tabla tabla;                         // Koriena tabla.
  private Label oznStanje;                     // Stanje igre.
                                               // Inicijalizacija.
  public Igra(Tabla tbl, Igra prvi, Igra drugi, Label sta) {
    igrai[0] = prvi; igrai[1] = drugi;
    tabla = tbl;
    tabla.prazni();
    tekIgra = 0;
    oznStanje = sta;
    oznStanje.setText(" ");
    start();
  }
  
  private boolean isto(int a, int b, int c)    // Da li su tri neprazne
      throws GreNeMoe {                         //   jednake oznake?
    return !tabla.oznaka(a).equals(" ") &&
           tabla.oznaka(a).equals(tabla.oznaka(b)) &&
           tabla.oznaka(a).equals(tabla.oznaka(c))    ;
  }

  public String stanje() {                     // Odreivanje stanja
    try {                                      //   igre.
      if (isto(0, 1, 2)) return tabla.oznaka(0);
      if (isto(3, 4, 5)) return tabla.oznaka(3);
      if (isto(6, 7, 8)) return tabla.oznaka(6);
      if (isto(0, 3, 6)) return tabla.oznaka(0);
      if (isto(1, 4, 7)) return tabla.oznaka(1);
      if (isto(2, 5, 8)) return tabla.oznaka(2);
      if (isto(0, 4, 8)) return tabla.oznaka(0);
      if (isto(2, 4, 6)) return tabla.oznaka(2);
      for (int i=0; i<9; i++)
        if (tabla.oznaka(i).equals(" ")) return " ";
      return "?";
    } catch (GreNeMoe g) { return null; }
  }
  
  @Override
  public void run() {                          // Telo niti.
    String stanje = " ";
    try {
      while (!interrupted() && stanje.equals(" ")) {
        igrai[tekIgra].odigrajPotez();
        tekIgra = 1 - tekIgra;
        stanje = stanje();
      }
      oznStanje.setText("Pobednik: " + stanje);
    } catch (InterruptedException g) {}
  }
  
  public void prekini() { interrupt(); }       // Prekidanje igre.
}
