// Tabla.java - Klasa tabli za igru XoX.

package xox;
import java.awt.*;
import java.awt.event.*;

public class Tabla {
  private Panel ploa;                         // Komp. za prikaz table.
  private Dugme[] dugmad = new Dugme [9];      // Polja table.
  private int pritisnuto;                      // Pritisnuto polje.

  private static class Dugme extends Button {  // Polje s pridruenim
    public int indeks;                         //   indeksom u tabli.
    public Dugme(int ind) { super(" "); indeks = ind; }
  }

  public Tabla(Panel plo) {                    // Inicijalizacija:
    (ploa=plo).setLayout(new GridLayout(3,3));// - ploa za polja,
    ploa.setEnabled(false);
    Font font = new Font(null, Font.BOLD, 24); // - vrsta slova za natpise,
    DugmeAkcija oslukiva = new DugmeAkcija();// - dugmad za polja.
    for(int i=0; i<9; i++) {
      ploa.add(dugmad[i] = new Dugme(i));
      dugmad[i].setFont(font);
      dugmad[i].addActionListener(oslukiva);
    }
  }

  public synchronized int uzmiPritisnuto() throws InterruptedException {
    ploa.setEnabled(true);          // Dohvatanje indeksa pritisnutog
    wait();                          // polja.
    ploa.setEnabled(false);
    return pritisnuto;
  }
                                     // Obrada pritisaka polja.
  private class DugmeAkcija implements ActionListener {
    @Override
    public void actionPerformed(ActionEvent dog) {
      pritisnuto = ((Dugme)dog.getSource()).indeks;
      dalje();
    }
  }

  private synchronized void dalje()  // Dojava da je polje pritisnuto.
    { notify(); }
                                     // Postavljanje oznake na polje.
  public void postaviOznaku(int ind, String  oznaka) throws GreNeMoe {
    if (ind<0 || ind>=9 || !dugmad[ind].getLabel().equals(" "))
      throw new GreNeMoe();
    dugmad[ind].setLabel(oznaka); dugmad[ind].setEnabled(false);
  }

  public void prazni() {             // Pranjenje table.
    for (int i=0; i<9; i++)
      { dugmad[i].setLabel(" "); dugmad[i].setEnabled(true); }
  }

  public String oznaka(int ind) throws GreNeMoe { // Dohvatanje oznake
    if (ind<0 || ind>=9) throw new GreNeMoe();    //   polja.
    return dugmad[ind].getLabel();
  }
}
