// Lista.java - Generika klasa listi podataka.

package kola;

public class Lista<E> {
  private static class Elem<T> {           // Element liste:
    T pod;                                 // - sadrani podatak,
    Elem<T> sled;                          // - sledei element,
    Elem(T p, Elem<T> s)                   // - inicijalizacija.
      { pod = p; sled = s; }
    Elem(T p) { this(p, null); }
  };
   
  private Elem<E> prvi, posl;              // Prvi i poslednji element.
  private Elem<E> tek, pret;               // Tekui i prethodni element.

  Lista<E> dodaj(E e) {                    // Dodavanje na kraj.
    Elem<E> novi = new Elem<E>(e);
    if (prvi == null) prvi = novi; else posl.sled = novi;
    posl = novi;
    return this;
  }
   
  Lista<E> naPrvi()                        // Postavljanje na prvi element.
    { tek = prvi; pret = null; return this; }

  Lista<E> naSled() {                      // Pomeranje na sledei element.
    pret = tek;
    if (tek != null) tek = tek.sled;
    return this;
  }
   
  boolean imaTek() { return tek != null; } // Ima li tekueg?
   
  E dohvTek() throws GreNemaTek {          // Pristup tekuem podatku:
    if (tek == null) throw new GreNemaTek();
    return tek.pod;
  }

  Lista<E> izbaciTek() throws GreNemaTek { // Izbacivanje tekueg elementa.
    if (tek == null) throw new GreNemaTek();
    tek = tek.sled;
    if (pret == null) prvi = tek; else pret.sled = tek;
    if (tek == null) posl = pret;
    return this;
  }
   
  Lista<E> isprazni() {                    // Pranjenje liste.
    prvi = posl = tek = pret = null;
    return this;
  }
};
